package jelite;

import java.io.*;
import java.awt.*;
import liaquay.collection.*;
import jelite.hulls.*;

public class Star
{
  private String _name;
  private int _x;
  private int _y;
  private int _z;
  private int _classification;
  private int _identifier;
  private ArrayList _satellites = new ArrayList();
  private Renderable _renderable;

  public Star( String name, int x, int y, int z, int classification, int identifier, Renderable renderable )
  {
    _name = name;
    _x = x;
    _y = y;
    _z = z;
    _classification = classification;
    _identifier = identifier;
    _renderable = renderable;
  }

  public final void addSatellite( Satellite satellite )
  {
    _satellites.add( satellite );
  }

  public String toString()
  {
     return _name + " " + _x + " " + _y + " " + _classification + " id=" + _identifier;
  }

  public boolean is( int x, int y, int z )
  {
    return ( _x == x ) && ( _y == y ) && ( _z == z );
  }

  public String getName()
  {
    return _name;
  }

  public int getX()
  {
    return _x;
  }

  public int getY()
  {
    return _y;
  }

  public int getZ()
  {
    return _z;
  }

  public int getIdentifier()
  {
    return _identifier;
  }

  public int getClassification()
  {
    return _classification;
  }

  public double getRadius()
  {
    return _renderable.getRadius();
  }

  public Renderable getRenderable()
  {
    return _renderable;
  }

  public ArrayList getSatellites()
  {
    return _satellites;
  }

  public final void calculatePosition( long ms )
  {
    for( int i = 0; i < _satellites.size(); ++i )
    {
      Satellite satellite = (Satellite)_satellites.get( i );
      satellite.calculatePosition( ms, 0, 0, 0 );
    }
  }
}
