package jelite.client;

import jelite.*;
import jelite.hulls.*;
import liaquay.collection.*;
import liaquay.math.vector.*;
import liaquay.graphics.*;

public class ClientStar implements SelectionListener
{
  private Transform _transform = new Transform();

  private Star _star;
  private boolean _renderSatellites = false;

  public ClientStar( Star star )
  {
    _star = star;
    setOrigin( 0, 0, 0 );
  }

  public void setOrigin( int sectorX, int sectorY, int sectorZ )
  {
    int starX = _star.getX();
    int starY = _star.getY();
    int starZ = _star.getZ();

    _transform.setDx( ( ( starX * Parameters.SOLAR_SYSTEM_SIZE_IN_SECTORS ) - sectorX ) * Parameters.SIZE_OF_SECTOR );
    _transform.setDy( ( ( starY * Parameters.SOLAR_SYSTEM_SIZE_IN_SECTORS ) - sectorY ) * Parameters.SIZE_OF_SECTOR );
    _transform.setDz( ( ( starZ * Parameters.SOLAR_SYSTEM_SIZE_IN_SECTORS ) - sectorZ ) * Parameters.SIZE_OF_SECTOR );
  }

  public Transform getTransform()
  {
    return _transform;
  }

  public Star getStar()
  {
    return _star;
  }

  public Renderable getRenderable()
  {
    return _star.getRenderable();
  }

  public int getIdentifier()
  {
    return _star.getIdentifier();
  }

  public void render( Graphics3D g )
  {
    getRenderable().render( g, _transform, this );
  }

  public void selected( Selection selection ){}

  public void deselected( Selection selection ){}
}
