package jelite.client;

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import jelite.engine.galaxy.Craft;
import liaquay.collection.*;
import liaquay.graphics.*;
import jelite.*;

public class EngineRoomPanel extends Panel
{
  private TextField _hyperX = new TextField( 8 );
  private TextField _hyperY = new TextField( 8 );
  private TextField _hyperZ = new TextField( 8 );
  private Selection _selection;
  private JEliteApplet _applet;

  class HyperdrivePanel extends Panel
  {
    HyperdrivePanel()
    {
      super( new FlowLayout(FlowLayout.CENTER,5,5) );
      Panel p1 = new Panel( new BorderLayout() );
      add( p1 );
      Panel labels = new Panel( new GridLayout( 3, 1 ) );
      p1.add( labels,BorderLayout.WEST );
      Panel fields = new Panel( new GridLayout( 3, 1 ) );
      p1.add( fields, BorderLayout.CENTER );
      labels.add( new Label( "X" ) );
      fields.add( _hyperX );
      labels.add( new Label( "Y" ) );
      fields.add( _hyperY );
      labels.add( new Label( "Z" ) );
      fields.add( _hyperZ );
      p1.add( new Label( "Hyperspace Coordinates" ), BorderLayout.NORTH );
      Panel controlPanel = new Panel( new FlowLayout(FlowLayout.CENTER,5,1) );
      p1.add( controlPanel, BorderLayout.SOUTH );
      Button setFromSelection = new Button( "Set From Selection" );

      controlPanel.add( setFromSelection );

      setFromSelection.addActionListener( new ActionListener()
      {
        public void actionPerformed(ActionEvent ev)
        {
          Iterator it = _selection.iterator();
          
          if( it.hasNext() )
          {
            Object o = it.next();
            
            if( o instanceof ClientStar )
            {

              ClientStar clientStar = (ClientStar)o;
              if( clientStar != null )
              {
                Star star = clientStar.getStar();
                int x = star.getX() * Parameters.SOLAR_SYSTEM_SIZE_IN_SECTORS;
                int y = star.getY() * Parameters.SOLAR_SYSTEM_SIZE_IN_SECTORS;
                int z = star.getZ() * Parameters.SOLAR_SYSTEM_SIZE_IN_SECTORS;
                _hyperX.setText( "" + x );
                _hyperY.setText( "" + y );
                _hyperZ.setText( "" + z );
              }
            }
          }
        }
      });
    }
  }

  public EngineRoomPanel( Selection selection, JEliteApplet applet )
  {
    _applet = applet;
    _selection = selection;

    setLayout( new NiceBorderLayout(0,0) );
    add( new HyperdrivePanel(), BorderLayout.CENTER );

    Panel controlPanel = new Panel( new FlowLayout(FlowLayout.CENTER,5,1) );
    add( controlPanel, BorderLayout.SOUTH );
    Button Hyperdrive = new Button( "Hyperdrive" );

    controlPanel.add( Hyperdrive );

    Hyperdrive.addActionListener( new ActionListener()
    {
      public void actionPerformed(ActionEvent ev)
      {
        try
        {
          int x = Integer.parseInt( _hyperX.getText() );
          int y = Integer.parseInt( _hyperY.getText() );
          int z = Integer.parseInt( _hyperZ.getText() );
          _applet.getCraft().hyperspace( x, y, z );
        }
        catch( NumberFormatException e )
        {
        }
      }
    });

  }

}