package jelite.client;

import java.awt.*;
import java.awt.event.*;
import jelite.engine.galaxy.*;
import jelite.engine.player.*;
import liaquay.math.vector.*;

public class LoginPanel extends Panel
{
  private JEliteApplet _applet;
  private TextField _userName = new TextField( "Jameson", 20 );
  private TextField _passWord = new TextField( "lemonhead", 20 );

  public LoginPanel( JEliteApplet applet )
  {
    super( new NiceBorderLayout(0,5) );
    _applet = applet;

    Panel labels = new Panel( new GridLayout( 2, 1 ) );
    Panel fields = new Panel( new GridLayout( 2, 1 ) );
    Panel buttons = new Panel( new FlowLayout(FlowLayout.CENTER,5,1) );
    //buttons.setBackground( Color.black );
    Panel c1 = new Panel( new FlowLayout(FlowLayout.CENTER,0,0) );
    Panel c2 = new Panel( new BorderLayout(0,0) );
    c1.add( c2 );
    c2.add( labels, BorderLayout.WEST );
    c2.add( fields, BorderLayout.CENTER );
    add( c1, BorderLayout.CENTER );
    add( buttons, BorderLayout.SOUTH );

    labels.add( new Label( "User Name" ) );
    fields.add( _userName );

    labels.add( new Label( "Password" ) );
    fields.add( _passWord );
    _passWord.setEchoChar( '*' );

    Button ok = new Button( "Login" );
    buttons.add( ok );

    Button cancel = new Button( "Disconnect" );
    buttons.add( cancel );

    ok.addActionListener( new ActionListener()
    {
      public void actionPerformed( ActionEvent e )
      {
        Player player = new HumanPlayer( _userName.getText(), _passWord.getText(), System.currentTimeMillis() );

        Sector sector = _applet.getGalaxy().getSector( null, -248, -496, -3566 );
        EliteCraft craft = new Cobra( Transform.createRotateTranslate( 0,0,0,0, 0, -1500 ) );
        sector.addNewItem( craft );

        craft.addCrewMember( player );
        player.setCraft( craft );
        _applet.setPlayer( player );
        _applet.setCraft( craft );

        _applet.changeState( JEliteApplet.STATE_FLYING );
      }
    });

    cancel.addActionListener( new ActionListener()
    {
      public void actionPerformed( ActionEvent e )
      {
      }
    });
  }
}