package jelite.client;

import liaquay.collection.*;
import jelite.*;

public class StarField
{
  private ArrayList _stars = new ArrayList();
  private int _sectorX = 0;
  private int _sectorY = 0;
  private int _sectorZ = 0;
  private StarMap _starMap = new StarMap();

  public StarField()
  {
    for( int i = 0; i < _starMap.numberOfStars(); ++i )
    {
      Star star = _starMap.getStar( i );
      ClientStar clientStar = new ClientStar( star );
      _stars.add( clientStar );
    }
  }

  public StarMap getStarMap()
  {
    return _starMap;
  }

  public ArrayList getStars()
  {
    return _stars;
  }

  public ClientStar nearest( int x, int y )
  {
    ClientStar nearest = null;
    int dd = 0;
    for( int i = 0; i < _stars.size(); ++i )
    {
      ClientStar clientStar = (ClientStar)_stars.get( i );
      Star star = clientStar.getStar();
      int starX = star.getX();
      int starY = star.getY();
      int dx = starX - x;
      int dy = starY - y;
      int ds = ( dx * dx ) + ( dy * dy );

      if( nearest == null )
      {
        nearest = clientStar;
        dd = ds;
      }
      else
      {
        if( ds < dd )
        {
          nearest = clientStar;
          dd = ds;
        }
      }
    }
    return nearest;
  }

  public ClientStar find( int id )
  {
    for( int i = 0; i < _stars.size(); ++i )
    {
      ClientStar clientStar = (ClientStar)_stars.get( i );
      Star star = clientStar.getStar();
      if( star.getIdentifier() == id )
      {
        return clientStar;
      }
    }
    return null;
  }

  public final void setOrigin( int sectorX, int sectorY, int sectorZ )
  {
    if( ( _sectorX != sectorX ) ||
        ( _sectorY != sectorY ) ||
        ( _sectorZ != sectorZ ) )
    {
      _sectorX = sectorX;
      _sectorY = sectorY;
      _sectorZ = sectorZ;

      for( int i = 0; i < _stars.size(); ++i )
      {
        ClientStar clientStar = (ClientStar)_stars.get( i );
        clientStar.setOrigin( sectorX, sectorY, sectorZ );
      }
    }
  }
}
