package jelite.client;

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import liaquay.collection.*;
import liaquay.graphics.*;
import jelite.*;

public class StarMapPanel extends Panel
{
  private JEliteApplet _applet;
  private StarMapCanvas _starMapCanvas;

  public StarMapPanel( Selection selection, JEliteApplet applet )
  {
    _starMapCanvas = new StarMapCanvas( selection, applet );
    _applet = applet;

    setLayout( new NiceBorderLayout(0,0) );
    add( _starMapCanvas, BorderLayout.CENTER );

    Panel controlPanel = new Panel( new FlowLayout(FlowLayout.CENTER,5,1) );
    add( controlPanel, BorderLayout.SOUTH );
    Button zoomIn = new Button( "Zoom In" );
    Button zoomOut = new Button( "Zoom Out" );
    Button panToSelection = new Button( "Pan to Selection" );
    controlPanel.add( zoomIn );
    controlPanel.add( zoomOut );
    controlPanel.add( panToSelection );

    zoomIn.addActionListener( new ActionListener()
    {
      public void actionPerformed(ActionEvent ev)
      {
        _starMapCanvas.zoomIn();
        _starMapCanvas.repaint();
      }
    });

    zoomOut.addActionListener( new ActionListener()
    {
      public void actionPerformed(ActionEvent ev)
      {
        _starMapCanvas.zoomOut();
        _starMapCanvas.repaint();
      }
    });

    panToSelection.addActionListener( new ActionListener()
    {
      public void actionPerformed(ActionEvent ev)
      {
        _starMapCanvas.panToSelection();
        _starMapCanvas.repaint();
      }
    });
  }
}