package jelite.client;

import java.awt.*;
import java.awt.event.*;
import liaquay.collection.*;

public class TabPanel extends Panel
{
  private Panel _controlPanel = new Panel(new FlowLayout(FlowLayout.CENTER,5,1) );
  private Panel _centerPanel = new Panel( new NiceBorderLayout(0,0) );
  private Hashtable _tabbedPanels = new Hashtable( 4 );
  private Component _frontComponent = null;

  class TabPanelButton extends Button
  {
    public TabPanelButton( String text )
    {
      super( text );

      addActionListener( new ActionListener()
      {
        public void actionPerformed(ActionEvent ev)
        {
          TabPanelEntry e = (TabPanelEntry)_tabbedPanels.get( getLabel() );
          if( _frontComponent != null )
          {
            _frontComponent.setVisible( false );
          }
          Component c = e.getComponent();
          c.setVisible( true );
          c.requestFocus();
          _frontComponent = c;
          validate();
        }
      });
    }
  }

  public TabPanel()
  {
    super( new NiceBorderLayout(0,0) );
    super.add( _controlPanel, BorderLayout.NORTH );
    super.add( _centerPanel, BorderLayout.CENTER );
    //_controlPanel.setBackground( Color.black );
    //_centerPanel.setBackground( Color.black );
  }

  public Component add( Component c )
  {
    add( c, c.getName() );
    return c;
  }

  public void add( Component c, String name )
  {
    TabPanelEntry e = new TabPanelEntry( name, c, new TabPanelButton( name ) );
    _tabbedPanels.put( name, e );
    _centerPanel.add( c, BorderLayout.CENTER );
    _controlPanel.add( e.getButton() );
    if( _frontComponent != null )
    {
      _frontComponent.setVisible( false );
    }
    c.setVisible( true );
    c.requestFocus();
    _frontComponent = c;
    validate();
  }

  public Iterator getTabPanelEntries()
  {
    return _tabbedPanels.iterator();
  }

  public Component getFrontComponent()
  {
    return _frontComponent;
  }

  public void setVisible( boolean b )
  {
    super.setVisible(b);
    if( _frontComponent != null )
    {
      _frontComponent.setVisible( b );
      _frontComponent.requestFocus();
    }
  }
}