package jelite.client;

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import liaquay.collection.*;
import liaquay.graphics.*;
import jelite.*;

public class ViewPanel extends Panel
{
  private JEliteApplet _applet;
  private ViewCanvas _viewCanvas;
  private static final float PI = (float)Math.PI;

  public ViewPanel( Selection selection, JEliteApplet applet )
  {
    _viewCanvas = new ViewCanvas( selection, applet );
    _applet = applet;

    setLayout( new NiceBorderLayout(0,0) );
    add( _viewCanvas, BorderLayout.CENTER );

    Panel controlPanel = new Panel( new FlowLayout(FlowLayout.CENTER,5,1) );
    add( controlPanel, BorderLayout.SOUTH );
    Button front = new Button( "Front" );
    Button back = new Button( "Back" );
    Button left = new Button( "Left" );
    Button right = new Button( "Right" );
    Button up = new Button( "Up" );
    Button down = new Button( "Down" );

    controlPanel.add( front );
    controlPanel.add( back );
    controlPanel.add( left );
    controlPanel.add( right );
    controlPanel.add( up );
    controlPanel.add( down );

    front.addActionListener( new ActionListener()
    {
      public void actionPerformed(ActionEvent ev)
      {
        _viewCanvas.rotateTranslate( 0,0,0,0,0,0 );
      }
    });

    back.addActionListener( new ActionListener()
    {
      public void actionPerformed(ActionEvent ev)
      {
        _viewCanvas.rotateTranslate( 0,PI,0,0,0,0 );
      }
    });

    left.addActionListener( new ActionListener()
    {
      public void actionPerformed(ActionEvent ev)
      {
        _viewCanvas.rotateTranslate( 0,-PI/2,0,0,0,0 );
      }
    });

    right.addActionListener( new ActionListener()
    {
      public void actionPerformed(ActionEvent ev)
      {
        _viewCanvas.rotateTranslate( 0,PI/2,0,0,0,0 );
      }
    });

    up.addActionListener( new ActionListener()
    {
      public void actionPerformed(ActionEvent ev)
      {
        _viewCanvas.rotateTranslate( -PI/2,0,0,0,0,0 );
      }
    });

    down.addActionListener( new ActionListener()
    {
      public void actionPerformed(ActionEvent ev)
      {
        _viewCanvas.rotateTranslate( PI/2,0,0,0,0,0 );
      }
    });
  }

  public void setVisible( boolean b )
  {
    super.setVisible(b);
    _viewCanvas.requestFocus();
  }

  public void requestFocus()
  {
    _viewCanvas.requestFocus();
  }

  public void paintNow()
  {
    _viewCanvas.paintNow();
  }
}
