package jelite.engine.galaxy;

import liaquay.math.vector.*;
import jelite.hulls.*;

public class Bullet extends InertialItem
{
  long creationTime;

  public Bullet( Renderable renderable, Transform transform, Transform inertia )
  {
    super( renderable, transform, inertia );
    creationTime = System.currentTimeMillis();
  }

  public void update( long ms, long period, Transform parentTransform )
  {
    if( System.currentTimeMillis() - creationTime > 8000 )
    {
      setDeceased();
      System.out.println( "Bullet to be removed" );
    }
    else
    {
      super.update( ms, period, parentTransform );
    }
  }

  public void collision( Item item, long period )
  {
    explode();
  }
}