package jelite.engine.galaxy;


public class ItemList
{
  private Item[] _items = new Item[ 50 ];
  private int _length = 0;

  public final void add( Item o )
  {
    if( _length == _items.length )
    {
      Item t[] = new Item[ _items.length * 2 ];
      for( int i = 0; i < _items.length; ++i )
      {
        t[ i ] = _items[ i ];
      }
      _items = t;
    }
    _items[ _length++ ] = o;
  }

  public final void remove( Item o )
  {
    Item e = null;

    for( int i = _length - 1; i >= 0; --i )
    {
      Item t = _items[ i ];

      _items[ i ] = e;

      if( t == o )
      {
        --_length;
        break;
      }

      e = t;
    }
  }

  public final void update( long ms, long period )
  {
    for( int i = 0; i < _length; ++i )
    {
      Item item = _items[ i ];
      item.update( ms, period, null );
    }
  }

/*
  public final void interact()
  {
    for( int i = 0; i < _length; ++i )
    {
      Item i1 = _items[ i ];

      for( int j = i + 1; j < _length; ++j )
      {
        Item i2 = _items[ j ];

        if( i1.checkCollision( i2 ) )
        {
          i1.collision( i2 );
          i2.collision( i1 );
        }

        if( i1.getDeceased() )
        {
          --i;
          break;
        }

        if( i2.getDeceased() )
        {
          --j;
        }
      }
    }
  }
*/
  public final Item checkCollision( Craft c )
  {
    for( int j = 0; j < _length; ++j )
    {
      Item i = _items[ j ];

      if( i.checkCollision( c ) )
      {
        return i;
      }
    }
    return null;
  }

}