package jelite.engine.galaxy;

import liaquay.math.vector.*;
import jelite.hulls.*;

public class LaunchTube
{
  private Transform _mountTransform;
  private SpaceStationItem _spaceStation;

  public LaunchTube( SpaceStationItem spaceStation, Transform mountTransform )
  {
    _spaceStation = spaceStation;
    _mountTransform = mountTransform;
  }

  /**
   * Launch an item from a tube
   * Note this does not take motion of the parent into account as it
   * is intended for space stations and slow moving things!!!
   * Space Station positions are closed form and velocity is not known.
   */
  public void launch( Craft craft )
  {
    Transform spaceStationTransform = _spaceStation.getTransform();

    // Take into account the size of the craft to avoid collision !!!!!!!
    // TO DO....

    Transform t = _mountTransform.mul( spaceStationTransform );
    Vector3D v = new Vector3D( 0, 0, 40 ).rot( spaceStationTransform );
    Transform u = new Transform();
    u.translate( v.get( 0 ), v.get( 1 ), v.get( 2 ) );

    craft.setTransform( t );
    //craft.setInertia( u );
    _spaceStation.getSector().addNewItem( craft );
  }
}