package jelite.engine.galaxy;

import liaquay.math.vector.*;

public class MissileLauncherMount
{
  private Transform _transform;
  private MissileLauncher _launcher = null;

  public MissileLauncherMount( Transform transform )
  {
    _transform = transform;
  }

  public void mount( MissileLauncher launcher )
  {
    _launcher = launcher;
  }

  public void fire( Sector sector,
                    Transform craftTransform,
                    Transform craftVelocity,
                    Craft target )
  {
    if( _launcher != null )
    {
      Transform t = _transform.mul( craftTransform );

      _launcher.fire( sector, t, craftVelocity, target );
    }
  }
}