package jelite.engine.galaxy;

import java.awt.*;

import jelite.hulls.*;
import liaquay.math.vector.*;
import liaquay.graphics.*;

public class Nova extends InertialItem
{
  private static final int STATE_EXPANDING = 0;
  private static final int STATE_COLLAPSING = 1;

  private int _state = STATE_EXPANDING;
  private double _maximumRadius;
  private double _radius;
  private Sphere _sphere;

  static PlainMaterial material1 = new PlainMaterial( new Colour( 1f,1f,0f ),
                                               new Colour( 0f,0f,0f ),
                                               1f );

  static Materials materials = new Materials( material1 );

  public Nova( Transform transform, double radius )
  {
    super( new Sphere( radius, materials ), transform );
    _radius = radius;
    _maximumRadius = radius * 4;
    _sphere = (Sphere)getRenderable();
  }

  public void update( long ms, long period, Transform parentTransform )
  {
//    Sphere sphere = (Sphere)_renderable;
    switch( _state )
    {
      case STATE_EXPANDING:

        _radius = _radius * 1.1f;
        if( _radius > _maximumRadius )
        {
          _state = STATE_COLLAPSING;
        }
        break;

      case STATE_COLLAPSING:
        _radius = _radius * 0.9f;
        {
          if( _radius < 10 )
          {
            setDeceased();
          }
        }
        break;
    }
    _sphere.setRadius( _radius );
    super.update( ms, period, parentTransform );
  }
}