package jelite.engine.galaxy;

import liaquay.math.vector.*;
import jelite.hulls.*;

public class PlasmaGun implements Gun
{
  public void fire( Sector sector,
                    Transform mountTransform,
                    Transform craftVelocity )
  {
    Vector3D v = new Vector3D( 0, 0, 4000 ).rot( mountTransform );

    v.set( 0, v.get( 0 ) + craftVelocity.getDx() );
    v.set( 1, v.get( 1 ) + craftVelocity.getDy() );
    v.set( 2, v.get( 2 ) + craftVelocity.getDz() );

    Transform u = new Transform();
    u.rotateTranslate(  0f, 0f, 2f, v.get( 0 ), v.get( 1 ), v.get( 2 ) );

    sector.addNewItem(
      new Bullet( Renderables.PLASMA, mountTransform, u ) );
  }
}
