package jelite.engine.galaxy;

import jelite.*;
import liaquay.math.vector.*;
import jelite.hulls.*;

public class SatelliteItem extends Item
{
  private double _radius;
  private long _period;
  private long _offset;
  private Item _parent;
  private Satellite _satellite;

  public SatelliteItem( Satellite satellite,
                        Item parent )
  {
    super( satellite.getRenderable(), new Transform() );
    _satellite = satellite;
    _parent = parent;
  }

  public final void calculatePosition( long ms )
  {
    double x = _satellite.getX();
    double y = _satellite.getY();
    double z = _satellite.getZ();

    double dx = _parent._transform.getDx() + ( x - ( ( _sector.getX() - _parent._sector.getX() ) * Sector.SIZE ) );
    double dy = _parent._transform.getDy() + ( y - ( ( _sector.getY() - _parent._sector.getY() ) * Sector.SIZE ) );
    double dz = _parent._transform.getDz() + ( z - ( ( _sector.getZ() - _parent._sector.getZ() ) * Sector.SIZE ) );

    _transform.translate( dx, dy, dz );
  }

  public void update( long ms, long period, Transform parentTransform )
  {
    calculatePosition( ms );
    super.update( ms, period, parentTransform );
  }
}