package jelite.engine.galaxy;

import liaquay.math.vector.*;


public class Thruster
{
  private double _thrust;
  private double _torque;
  private Vector3D _direction;
  private double _p = 0;

  public Thruster( double x, double y, double z, double thrust, double torque )
  {
    _direction = new Vector3D( x, y, z );
    _thrust = thrust;
    _torque = torque;
  }

  public final void setPower( double p )
  {
    _p = p;
  }

  public final double getPower()
  {
    return _p;
  }

  public final boolean burning()
  {
    return _p > 0;
  }

  public final Transform getTransform( Transform craftTransform, long period )
  {
    // Integrate power and time
    double m = period * _p / 1000;

    // Rotate the engine to world coords
    Vector3D direction = _direction.rot( craftTransform );

    Transform transform = new Transform();
    transform.rotateTranslate(
      direction.get( 0 ), direction.get( 1 ), direction.get( 2 ),
      _torque * m,
      direction.get( 0 ) * _thrust * m,
      direction.get( 1 ) * _thrust * m,
      direction.get( 2 ) * _thrust * m );

    return transform;
  }
}
