package jelite.engine.galaxy.pilot;

import jelite.engine.galaxy.Craft;
import liaquay.math.vector.*;

public class FaceAwayFromEnemyAction extends CraftAction
{
  private Vector3D _relativePosition;
  private double _engineSetting;

  /**
   *
   */
  public FaceAwayFromEnemyAction( long birthdate,
                                  long longevity,
                                  Craft self,
                                  Craft enemy,
                                  double engineSetting,
                                  Vector3D relativePosition )
  {
    super( birthdate, longevity, self );
    _relativePosition = relativePosition;
    _engineSetting = engineSetting;
  }

  public void perform( long ms, long period )
  {
   // System.out.println( "Performing FaceAwayFromEnemyAction action" );

    Craft self = getSelf();

    self.setThrusterPower( 0, _engineSetting / 4 );
    self.setThrusterPower( 1, 0.0 );

    double x = _relativePosition.get(0);
    double y = _relativePosition.get(1);

    if( (x < 5) && (x > -5) )
    {
      self.setThrusterPower( 2, 0.0 );
      self.setThrusterPower( 3, 0.0 );
    }
    else if( ( x > 0 ) == ( y > 0 ) )
    {
      self.setThrusterPower( 2, 0.0 );
      self.setThrusterPower( 3, 1.0 );
    }
    else
    {
      self.setThrusterPower( 2, 1.0 );
      self.setThrusterPower( 3, 0.0 );
    }

    double modx = x >= 0 ? x : -x;
    double mody = y >= 0 ? y : -y;

    if( modx < 40 )
    {
      if( mody > 40 )
      {
        if( y < 0 )
        {
          self.setThrusterPower( 6, 0.0 );
          self.setThrusterPower( 7, 1.0 );
        }
        else
        {
          self.setThrusterPower( 6, 1.0 );
          self.setThrusterPower( 7, 0.0 );
        }
      }
      else
      {
        self.setThrusterPower( 0, _engineSetting );
      }
    }
    else
    {
      self.setThrusterPower( 6, 0.0 );
      self.setThrusterPower( 7, 0.0 );
    }
  }
}

