package jelite.engine.galaxy.pilot;

import jelite.engine.galaxy.Craft;

public class FlyStraightAction extends CraftAction
{
  private boolean _courseSet = false;
  private double _power;
  /**
   * Create a fly-straight action supplying its birthdate.
   */
  public FlyStraightAction( long birthdate, long longevity, Craft self, double power )
  {
    super( birthdate, longevity, self );
    _power = power;
  }

  public void perform( long ms, long period )
  {
    if( !_courseSet )
    {
      //System.out.println( "Performing fly-straight action" );
      
      Craft self = getSelf();
      
      self.allThrustersOff();
      self.setThrusterPower( 0, _power );    
    }
  }

}
