package jelite.engine.galaxy.pilot.missile;

import jelite.engine.galaxy.Craft;
import liaquay.math.vector.*;
import jelite.engine.galaxy.pilot.*;

public class EngagementAction extends CraftAction
{
  // This is the craft this action is attacking
  private Craft _enemy;

  // The relative position of the enemy craft
  private Vector3D _relativePosition = new Vector3D(0,0,0);

  /**
   * Create an engage the enemy action supplying its birthdate.
   */
  public EngagementAction( long birthdate, Craft self, Craft enemy )
  {
    super( birthdate, 60000, self );
    _enemy = enemy;

  }

  // The inverse of the self transform
  private Transform _inverseSelf = new Transform();

  // The combined transform for self and enemy
  private Transform _combinedTransform = new Transform();

  // Relative position of enemy to self in world coordinates
  private Vector3D _relativePositionWorld = new Vector3D(0,0,0);


  public void perform( long ms, long period )
  {
    //System.out.println( "Performing engagement action" );

    Craft self = getSelf();

    if( self.getDeceased() || _enemy.getDeceased() )
    {
      setCompleted();
      return;
    }

    getSelf().getTransform().inverse( _inverseSelf );
    //_enemy.getTransform().mul( _inverseSelf, _combinedTransform );

    getSelf().getRelativePosition( _enemy, _relativePositionWorld );

    _relativePositionWorld.rot( _inverseSelf, _relativePosition );

    if( getSubActions().size() == 0 )
    {
      add( new FaceTowardsEnemyAction( ms, 8000, self, _enemy, 2.0, _relativePosition ) );
    }
  }
}
