package jelite.engine.galaxy.pilot.missile;

import jelite.engine.galaxy.*;
import jelite.engine.player.*;
import jelite.engine.galaxy.pilot.*;

public class TopLevelAction extends CraftAction
{
  private Craft _target;

  /**
   * Create a top-level action supplying its birthdate.
   */
  public TopLevelAction( long birthdate, Craft self, Craft target )
  {
    super( birthdate, 1000000000000L, self );
    _target = target;
  }

  public void perform( long ms, long period )
  {
    //System.out.println( "Performing top-level action" );

    if( ms - getBirthdate() > 20000 )
    {
      getSelf().explode();
    }

    if( _target != null && _target.getDeceased() )
    {
      clearSubActions();
      _target = null;
    }

    if( getSubActions().size() == 0 )
    {

      if( _target != null )
      {
        EngagementAction action = new EngagementAction( ms, getSelf(), _target );

        add( action );
      }
      else
      {
        CruiseAction action = new CruiseAction( ms, getSelf() );

        add( action );
      }
    }
  }
}
