package jelite.hulls;

import java.awt.Color;

public class Material
{
  float _redReflective;
  float _greenReflective;
  float _blueReflective;
  float _redEmissive;
  float _greenEmissive;
  float _blueEmissive;

  public Material( float redReflective,
                   float greenReflective,
                   float blueReflective,
                   float redEmissive,
                   float greenEmissive,
                   float blueEmissive )
  {
    _redReflective = redReflective;
    _greenReflective = greenReflective;
    _blueReflective = blueReflective;
    _redEmissive = redEmissive;
    _greenEmissive = greenEmissive;
    _blueEmissive = blueEmissive;
  }

  public Color getColor( float brightness )
  {
    float red = _redEmissive + ( brightness * _redReflective );
    float green = _greenEmissive + ( brightness * _greenReflective );
    float blue = _blueEmissive + ( brightness * _blueReflective );

    int r = (int)(red * 255);
    int g = (int)(green * 255);
    int b = (int)(blue * 255);

    if( r > 255 ) r = 255;
    if( g > 255 ) g = 255;
    if( b > 255 ) b = 255;

    return new Color( r, g, b );
  }

  public Color getReflectiveColor()
  {
    return new Color( _redReflective, _greenReflective, _blueReflective );
  }

  public Color getEmissiveColor()
  {
    return new Color( _redEmissive, _greenEmissive, _blueEmissive );
  }

  public void setReflectiveColor( Color color )
  {
    float[] c = color.getRGBComponents(null);
    _redReflective = c[ 0 ];
    _greenReflective = c[ 1 ];
    _blueReflective = c[ 2 ];
  }

  public void setEmissiveColor( Color color )
  {
    float[] c = color.getRGBComponents(null);
    _redEmissive = c[ 0 ];
    _greenEmissive = c[ 1 ];
    _blueEmissive = c[ 2 ];
  }

  public String toString()
  {
    return "(" +
           _redReflective +
           " " +
           _greenReflective +
           " " +
           _blueReflective +
           " " +
           _redEmissive +
           " " +
           _greenEmissive +
           " " +
           _blueEmissive +
           ")";
  }
}