package jelite.hulls;

import java.io.*;
import java.awt.*;
import java.net.*;
import liaquay.graphics.*;

public class Renderables
{
  static PlainMaterial material1 = new PlainMaterial( new Colour( 1f,1f,1f ),
                                               new Colour( 0f,0f,0f ),
                                               1f );

  static PlainMaterial material2 = new PlainMaterial( new Colour( 1f,0f,0f ),
                                               new Colour( 0f,0f,0f ),
                                               1f );

  static TexturedMaterial texture1 = new ArrayImageMaterial( TextureFactory.SKY( 512, 512, 7f ), 1.0d, 1.0f, false );

  static TexturedMaterial texture2 = new ArrayImageMaterial( TextureFactory.WOOD( 512, 512, 1f ), 1.0d, 1.0f, false );

  static Materials materialsStar = new Materials( material1 );

  static Materials materialsPlasma = new Materials( material2 );

  static Materials materialsPlanet1 = new Materials( material1, texture1 );

  static Materials materialsPlanet2 = new Materials( material1, texture2 );

  public static final Renderable COBRA = new LoadOnDemandHull( "Cobra" );
  public static final Renderable ANACONDA = new LoadOnDemandHull( "Anaconda" );
  public static final Renderable ASP = new LoadOnDemandHull( "Asp" );
  public static final Renderable ASTEROID = new LoadOnDemandHull( "Asteroid" );
  public static final Renderable BARREL = new LoadOnDemandHull( "Barrel" );
  public static final Renderable BOA = new LoadOnDemandHull( "Boa" );
  public static final Renderable BOULDER = new LoadOnDemandHull( "Boulder" );
  public static final Renderable CAPSULE = new LoadOnDemandHull( "Capsule" );
  public static final Renderable COBRAMK1 = new LoadOnDemandHull( "CobraMk1" ) ;
  public static final Renderable CONSTRICTOR = new LoadOnDemandHull( "Constrictor" );
  public static final Renderable CORIOLIS = new LoadOnDemandHull( "Coriolis" );
  public static final Renderable COUGAR = new LoadOnDemandHull( "Cougar" );
  public static final Renderable DODO = new LoadOnDemandHull( "Dodo" );
  public static final Renderable FERDELANCE = new LoadOnDemandHull( "Ferdelance" );
  public static final Renderable GECKO = new LoadOnDemandHull( "Gecko" );
  public static final Renderable KRAIT = new LoadOnDemandHull( "Krait" );
  public static final Renderable MAMBA = new LoadOnDemandHull( "Mamba" );
  public static final Renderable MISSILE = new LoadOnDemandHull( "Missile" );
  public static final Renderable MORAY = new LoadOnDemandHull( "Moray" );
  public static final Renderable PYTHON = new LoadOnDemandHull( "Python" );
  public static final Renderable SHUTTLE = new LoadOnDemandHull( "Shuttle" );
  public static final Renderable SIDEWINDER = new LoadOnDemandHull( "Sidewinder" );
  public static final Renderable THARGLET = new LoadOnDemandHull( "Tharglet" );
  public static final Renderable THARGOID = new LoadOnDemandHull( "Thargoid" );
  public static final Renderable TRANSPORTER = new LoadOnDemandHull( "Transporter" );
  public static final Renderable VIPER = new LoadOnDemandHull( "Viper" );
  public static final Renderable WORM = new LoadOnDemandHull( "Worm" );
  public static final Renderable STAR1 = new Sphere( 40000, materialsStar );
  public static final Renderable WHITE_DAWF = new Sphere( 2000, materialsStar );
  public static final Renderable PLANET1 = new Sphere( 2000, materialsPlanet1 );
  public static final Renderable PLANET2 = new Sphere( 4000, materialsPlanet2 );
  public static final Renderable PLANET3 = new Sphere( 8000, materialsPlanet1 );
  public static final Renderable PLANET4 = new Sphere( 12000, materialsPlanet2 );
  public static final Renderable PLANET5 = new Sphere( 14000, materialsPlanet1 );
  public static final Renderable PLANET6 = new Sphere( 16000, materialsPlanet2 );
  public static final Renderable PLASMA = new Sphere( 50, materialsPlasma );
  //public static final Renderable PLASMA = new OpaqueSolid3DRenderable( jelite.graphics.test.FourOctohedra.create() );

  private static Renderable[] renderables = new Renderable[ 35 ];

  static
  {
    renderables[ 0  ] = COBRA;
    renderables[ 1  ] = ANACONDA;
    renderables[ 2  ] = ASP;
    renderables[ 3  ] = ASTEROID;
    renderables[ 4  ] = BARREL;
    renderables[ 5  ] = BOA;
    renderables[ 6  ] = BOULDER;
    renderables[ 7  ] = CAPSULE;
    renderables[ 8  ] = COBRAMK1;
    renderables[ 9  ] = CONSTRICTOR;
    renderables[ 10 ] = CORIOLIS;
    renderables[ 11 ] = COUGAR;
    renderables[ 12 ] = DODO;
    renderables[ 13 ] = FERDELANCE;
    renderables[ 14 ] = GECKO;
    renderables[ 15 ] = KRAIT;
    renderables[ 16 ] = MAMBA;
    renderables[ 17 ] = MISSILE;
    renderables[ 18 ] = MORAY;
    renderables[ 19 ] = PYTHON;
    renderables[ 20 ] = SHUTTLE;
    renderables[ 21 ] = SIDEWINDER;
    renderables[ 22 ] = THARGLET;
    renderables[ 23 ] = THARGOID;
    renderables[ 24 ] = TRANSPORTER;
    renderables[ 25 ] = VIPER;
    renderables[ 26 ] = WORM;
    renderables[ 27 ] = STAR1;
    renderables[ 28 ] = WHITE_DAWF;
    renderables[ 29 ] = PLANET1;
    renderables[ 30 ] = PLANET2;
    renderables[ 31 ] = PLANET3;
    renderables[ 32 ] = PLANET4;
    renderables[ 33 ] = PLANET5;
    renderables[ 34 ] = PLANET6;
  }

  public static Renderable get( int i )
  {
    return renderables[ i ];
  }

  public static int size()
  {
    return renderables.length;
  }
}
