package jelite.hulls;

import java.awt.*;
import liaquay.graphics.*;
import liaquay.math.vector.*;

public class Sphere implements Renderable
{
  private OpaqueSphere3D _sphere;

  public Sphere( double radius, Materials materials )
  {
    _sphere = new OpaqueSphere3D(
      new Sphere3D( radius, new Vector3D(0,0,0) ),
      materials
    );
  }

  public Sphere( OpaqueSphere3D sphere )
  {
    _sphere = sphere;
  }

  public void render( Graphics3D g, Transform transform, SelectionListener listener )
  {
    g.add( _sphere, transform, listener );
  }

    public double getRadius()
    {
      return _sphere.getSphere3D().getRadius();
  }

  public void setRadius( double radius )
  {
    _sphere.getSphere3D().setRadius( radius );
  }
}