package liaquay.collection;

public class BinarySearcher implements Searcher
{
  /**
    *   Returns the position of the object searched for in s
    *   returns -1 if object is not within the list
    */
  public int search( Searchable s )
  {
    int size = s.size();
    int start = 0;
    int end = size-1;

    int pos=(start+end)/2;

    int compare;

    // while our position is not the position of the object
    // searched for
    while ((compare = s.compare(pos))!=0)
    {
      // if our object is after the current position
      // then up the position by half again
      if (compare>0)
      {
        start=pos+1;
      }
      // if our object is below the current position
      // then lower the position by half
      else
      {
        end=pos-1;
      }

      if (start>=size || end<0 )
      {
        return -1;
      }
      pos = (start+end)/2;
    }
    return pos;
  }
}