package liaquay.collection;

public class CombinedIterator implements Iterator
{
  private Iterator[] _iterators;
  private int _index = 0;

  public CombinedIterator( Iterator[] iterators )
  {
    _iterators = iterators;
  }

  public Object next()
  {
    Iterator iterator = _iterators[ _index ];

    while( !iterator.hasNext() )
    {
      if( _index < _iterators.length - 1 )
      {
        iterator = _iterators[ ++_index ];
      }
      else
      {
        return null;
      }
    }

    return iterator.next();
  }

  public boolean hasNext()
  {
    Iterator iterator = _iterators[ _index ];

    while( !iterator.hasNext() )
    {
      if( _index < _iterators.length - 1 )
      {
        iterator = _iterators[ ++_index ];
      }
      else
      {
        return false;
      }
    }

    return iterator.hasNext();
  }

}
