package liaquay.collection;

public class Fifo
{
  Object[] _objects;
  int _w = 0;
  int _r = 0;

  public Fifo( int length )
  {
    _objects = new Object[ length + 1 ];
  }

  public void put( Object o )
  {
    _objects[ _w ] = o;
    _w = ( _w + 1 ) % _objects.length;
    if( _w == _r )
    {
      throw new RuntimeException( "FIFO overrun" );
    }
  }

  public Object get()
  {
    if( _w == _r )
    {
      throw new RuntimeException( "FIFO underrun" );
    }
    else
    {
      Object o = _objects[ _r ];
      _r = ( _r + 1 ) % _objects.length;
      return o;
    }
  }

  public boolean isEmpty()
  {
    return _r == _w;
  }

  public boolean isFull()
  {
    return ( ( _w + 1 ) % _objects.length ) == _r;
  }

  public void removeAll()
  {
    _w = 0;
    _r = 0;
  }
}