package liaquay.collection;

import liaquay.math.set.*;

public class MappedObjectArray implements ObjectArray
{
  private ObjectArray _objectArray;
  private IntegerBijection _map;

  public MappedObjectArray( ObjectArray objectArray, IntegerBijection map )
  {
    _objectArray = objectArray;
    _map = map;
  }

  /**
   * Get the object at index i
   */
  public Object get( int i )
  {
    return _objectArray.get( _map.map( i ) );
  }

  /**
   * Set the object at index i.
   * @return The previous object at index i.
   */
  public Object set( int i, Object o )
  {
    return _objectArray.set( _map.map( i ), o );
  }

  /**
   * The size of the array
   */
  public int size()
  {
    return _objectArray.size();
  }
}
