package liaquay.collection;

/**
  * This class contains an object and its comparator.
  */
public class ObjectLocator
{

  private Object _object;
  private ObjectComparator _objectComparator;

  public ObjectLocator( Object object,
                        ObjectComparator objectComparator )
  {
    _object = object;
    _objectComparator = objectComparator;
  }

  /**
   * Compare the element passed in ( call this o2) with the object
   * contained in this locator (call this o1) using the comparator.
   * <p> If o1<o2 return negative result
   * <p> If o1>o2 return positive result
   * <p> If o1=o2 return zero
   */
  public int compare( Object o )
  {
    return _objectComparator.compare( _object, o );
  }

  /**
   * Set the comparator to be used with this locator.
   */
  public void setComparator( ObjectComparator objectComparator )
  {
    _objectComparator = objectComparator;
  }

 /**
  * Set the object to be used with this locator.
  */
  public void setObject( Object object )
  {
    _object = object;
  }

}