package liaquay.collection;

/**
 * A quick sorter.
 */
public class QuickSorter implements Sorter
{
  public static final Sorter SORTER = new QuickSorter();

  public void sort( Sortable s )
  {
    if( s.size() > 1 )
    {
      quickSort( s, 0, s.size() - 1 );
    }
  }

  private final void quickSort( Sortable s, int f, int l )
  {
    if( f == l )
    {
    }
    else if( l - f < 9 )
    {
      selectionSort( s, f, l );
    }
    else
    {
      int pivotIndex = partition( s, f, l );
      quickSort( s, f, pivotIndex - 1 );
      quickSort( s, pivotIndex + 1, l );
    }
  }

  private final int partition( Sortable s, int f, int l )
  {
    int fi = f;
    int li = l;

    int pivot = f;

    ++f;

    while( f < l )
    {
      while( ( f < l ) && ( s.compare( f, pivot ) <= 0  ) )
      {
        ++f;
      }

      while( ( f <= l ) && ( s.compare( l, pivot ) >= 0  ) )
      {
        --l;
      }

      if( f < l )
      {
        s.swap( f, l );
      }
    }

    s.swap( fi, l );

    return l;
  }

  private static final void selectionSort( Sortable s, int f, int l )
  {
    for( int i = f; i <= l; ++i )
    {
      for( int j = i + 1; j <= l; ++j )
      {
        if( s.compare( i, j ) > 0 )
        {
          s.swap( i, j );
        }
      }
    }
  }
}
