package liaquay.collection;

/**
 * Classes that implement this interface can be searched by {@link Searcher}s.
 */

public interface Searchable
{
  /**
   * The size of the searchable list
   */
  public int size();

  /**
   * Compare elements at index i with the object being sought.
   * <p> If object is after position i (o>i) return positive result
   * <p> If object is before i (o<i) return negative result
   * <p> If object is at position i (o=i) return zero
   */
  public int compare( int i );

}