package liaquay.collection;

public class SearchableObjectArray implements Searchable
{
  private ObjectLocator _objectLocator = null;
  private ObjectArray _objectArray = null;

  public SearchableObjectArray (ObjectArray objectArray,
                                ObjectLocator objectLocator)
  {
    _objectLocator=objectLocator;
    _objectArray=objectArray;
  }

  /**
   * The size of the searchable list
   */
  public int size()
  {
    return _objectArray.size();
  }

  /**
   * Compare elements at index i with the object being sought.
   * <p> If object is after position i (o>i) return positive result
   * <p> If object is before i (o<i) return negative result
   * <p> If object is at position i (o=i) return zero
   */
  public int compare( int i )
  {
    return _objectLocator.compare( _objectArray.get(i) );
  }

}