package liaquay.collection;

/**
 * Classes that implement this interface can be sorted by {@link Sorter}s.
 */
public interface Sortable
{
  /**
   * Swaps the elements at indexes i and j.
   */
  public void swap( int i, int j );

  /**
   * The size of the sortable list
   */
  public int size();

  /**
   * Compare elements at indexes i and j.
   * <p> If o1 < o2 returns positive result
   * <p> If o1 > o2 returns negative result
   * <p> If o1 = o2 returns zero
   */
  public int compare( int i, int j );
}
