package liaquay.collection;

public class SyncFifo extends Fifo
{
  public SyncFifo( int length )
  {
    super( length );
  }

  public synchronized void put( Object o )
  {
    while( isFull() )
    {
      try
      {
        wait();
      }
      catch( InterruptedException e )
      {
      }
    }
    super.put( o );
    notify();
  }

  public synchronized Object get()
  {
    if( isEmpty() )
    {
      try
      {
        wait();
      }
      catch( InterruptedException e )
      {
      }
    }
    if( isEmpty() )
    {
      return null;
    }
    else
    {
      Object o = super.get();
      notify();
      return o;
    }
  }


  public synchronized Object get( long timeout )
  {
    if( isEmpty() )
    {
      try
      {
        wait( timeout );
      }
      catch( InterruptedException e )
      {
      }
    }
    if( isEmpty() )
    {
      return null;
    }
    else
    {
      Object o = super.get();
      notify();
      return o;
    }
  }

  public synchronized void interrupt()
  {
    notifyAll();
  }
}