package liaquay.collection.test;

import junit.framework.*;
import liaquay.collection.*;

/**
 * CombinedIterator tests.
 */
public class CombinedIteratorTest extends TestCase
{
  public CombinedIteratorTest(String name)
  {
    super(name);
  }

  public static Test suite()
  {
    /*
     * the dynamic way
     */
    return new TestSuite(CombinedIteratorTest.class);
  }

  public static void main (String[] args)
  {
    junit.textui.TestRunner.run (suite());
  }

  public void test1()
  {
    ArrayList list1 = new ArrayList();
    ArrayList list2 = new ArrayList();

    CombinedIterator it = new CombinedIterator( new Iterator[] {
                                                  list1.iterator(),
                                                  list2.iterator() } );

    assertEquals( false, it.hasNext() );
  }

  public void test2()
  {
    ArrayList list1 = new ArrayList();
    ArrayList list2 = new ArrayList();

    Object object1 = new Integer( 1 );

    list1.add( object1 );

    CombinedIterator it = new CombinedIterator( new Iterator[] {
                                                  list1.iterator(),
                                                  list2.iterator() } );

    assertEquals( true, it.hasNext() );
    assertEquals( object1, it.next() );
    assertEquals( false, it.hasNext() );
  }

  public void test3()
  {
    ArrayList list1 = new ArrayList();
    ArrayList list2 = new ArrayList();

    Object object1 = new Integer( 1 );

    list2.add( object1 );

    CombinedIterator it = new CombinedIterator( new Iterator[] {
                                                  list1.iterator(),
                                                  list2.iterator() } );

    assertEquals( true, it.hasNext() );
    assertEquals( object1, it.next() );
    assertEquals( false, it.hasNext() );
  }
}