package liaquay.collection.test;

import junit.framework.*;
import liaquay.collection.Hashtable;
import liaquay.collection.Iterator;

/**
 * Hashtable tests.
 *
 */
public class HashtableTest extends TestCase 
{


  public HashtableTest(String name) 
  {
    super(name);
  }

  
  public static Test suite() 
  {
    /*
     * the dynamic way
     */
    return new TestSuite(HashtableTest.class);
  }
  
  
  public void testRehash()
  {
    // as far as I know at the moment rehash
    // happens at a load value of 0.75. This
    // may change in the future, but as it is a private
    // variable, I can't check it here!!!
    
    // make a hashtable with a width of 4
    Hashtable testHash = new Hashtable(4);
    // now add three items to it. This brings it to it's
    // limit before it rehashes
    testHash.put("1", "one");
    testHash.put("2", "two");
    testHash.put("3", "three");
    assertTrue( testHash.getWidth()==4);
    
    // now add one more to it, causing it to rehash.
    testHash.put("4", "four");
    assertTrue( testHash.getWidth()>4);     
    String one = (String)testHash.get("1");
    String two = (String)testHash.get("2");
    String three = (String)testHash.get("3");
    String four = (String)testHash.get("4");
    assertEquals(one, "one");
    assertEquals(two, "two");
    assertEquals(three, "three");
    assertEquals(four, "four");
  }
  
  public void testIterator()
  {
    Hashtable testHash = new Hashtable();
    testHash.put("1", "one");
    testHash.put("2", "two");
    testHash.put("3", "three");
    Iterator i=testHash.iterator();
    int count=1;
    while(i.hasNext())
    {
      if (count==1)
      {
        assertEquals((String)i.next(), "one");
      }
      if (count==2)
      {
        assertEquals((String)i.next(), "two");
      }
      if (count==3)
      {
        assertEquals((String)i.next(), "three");
      }
      
      count++;
    }
    
  }
  
  public void testKeyIterator()
  {
    Hashtable testHash = new Hashtable();
    testHash.put("1", "one");
    testHash.put("2", "two");
    testHash.put("3", "three");
    Iterator i=testHash.keyIterator();
    int count=1;
    while(i.hasNext())
    {
      if (count==1)
      {
        assertEquals((String)i.next(), "1");
      }
      if (count==2)
      {
        assertEquals((String)i.next(), "2");
      }
      if (count==3)
      {
        assertEquals((String)i.next(), "3");
      }
      
      count++;
    }
    
  }
}