package liaquay.collection.test;

import junit.framework.*;
import liaquay.collection.*;



/**
 * QuickSorter tests.
 */
public class QuickSorterTest extends TestCase
{
  public QuickSorterTest(String name)
  {
    super(name);
  }

  public static Test suite()
  {
    /*
     * the dynamic way
     */
    return new TestSuite(QuickSorterTest.class);
  }

  private ArrayList makeList( int length )
  {
    ArrayList list = new ArrayList( length );

    for( int i = 0; i < length; ++i )
    {
      list.add( new Double( Math.random() ) );
    }

    return list;
  }

  private void checkList( ArrayList list )
  {
    if( list.size() > 0 )
    {
      double v = ((Double)list.get( 0 )).doubleValue();

      for( int i = 1; i < list.size(); ++i )
      {
        double vn = ((Double)list.get( 0 )).doubleValue();
        if( v > vn )
        {
          fail( "list is not ordered" );
        }
      }
    }
  }

  private void checkList( int length )
  {
    ArrayList list1 = makeList( length );

    Sorter sorter = new QuickSorter();

    SortableObjectArray sortable = new SortableObjectArray( list1, new ComparableComparator() );

    sorter.sort( sortable );

    checkList( list1 );
  }

  public void testEmptyList()
  {
    checkList( 0 );
  }


  public void testSingleEntryInList()
  {
    checkList( 1 );
  }

  public void testTwoEntriesInList()
  {
    checkList( 2 );
    checkList( 2 );
    checkList( 2 );
    checkList( 2 );
    checkList( 2 );
  }

  public void testLargeList()
  {
    checkList( 3000 );
  }


}