package liaquay.graphics;

import java.awt.*;

public class Colour
{
  public static Colour BLACK = new Colour( 0.0f, 0.0f ,0.0f );
  public static Colour WHITE = new Colour( 1.0f, 1.0f, 1.0f );

  private float _red;
  private float _green;
  private float _blue;

  private int _rgb;

  public Colour()
  {
    _red = 0;
    _green = 0;
    _blue = 0;

    build();
  }

  public Colour( float red, float green, float blue )
  {
    _red = red;
    _green = green;
    _blue = blue;

    build();
  }

  public Colour( Colour c )
  {
    _red = c._red;
    _green = c._green;
    _blue = c._blue;

    build();
  }

  public Colour( Color c )
  {
    _red = (float)c.getRed() / 255.0f;
    _green = (float)c.getGreen() / 255.0f;
    _blue = (float)c.getBlue() / 255.0f;

    build();
  }

  public float getRed()
  {
    return _red;
  }

  public float getGreen()
  {
    return _green;
  }

  public float getBlue()
  {
    return _blue;
  }

  public Color getColor()
  {
    return new Color( _red, _green, _blue );
  }

  public String toString()
  {
    return "(" + _red + " " + _green + " " + _blue + ")";
  }

  public final int getRGB()
  {
    return _rgb;
  }

  private void build()
  {
    _rgb = 0xFF000000 | (((int)(255 * _red))<<16) | (((int)(255 * _green))<<8) | ((int)(255 * _blue));
  }

}