package liaquay.graphics;

import liaquay.math.vector.*;
import java.awt.*;

public interface Graphics3D
{
  /**
   * Prepares the renderer for new a new scene.
   */
  public void beginScene( Camera3D camera );

  /**
   * Add an object to the scene.
   */
  public void add( OpaqueSolid3D solid,
                   Transform transform,
                   SelectionListener selectionListener );

  public void add( TranslucentSolid3D solid,
                   Transform transform,
                   SelectionListener selectionListener );

  public void add( OpaqueSphere3D sphere,
                   Transform transform,
                   SelectionListener selectionListener );

  public void add( TranslucentSphere3D sphere,
                   Transform transform,
                   SelectionListener selectionListener );

  public void add( OpaquePlane3D plane,
                   Transform transform,
                   SelectionListener selectionListener );

  /**
   * Compeletes the scene.
   */
  public void endScene();

  /**
   * Deliver a pick event to the graphics engine.
   * This will result in the appropriate selection listener being activated.
   * Only use this method after a call to endScene().
   */
  public void pick( int x, int y );

  /**
   * Get an image representing the rendered scene.
   */
  public Image getImage();
}
