package liaquay.graphics;

import liaquay.math.vector.*;

public class OpaqueSolid3DBuilder extends Solid3DBuilder
{
  private PlainMaterial _material1 = new PlainMaterial( new Colour( 1.00f, 0.75f, 0.75f ),
                                                 new Colour( 0f,0f,0f ),
                                                 0f );

  private Materials _materials1 = new Materials( _material1 );


  public OpaqueSolid3D buildOpaqueSolid3D()
  {
    Solid3D solid = buildSolid3D();

    return new OpaqueSolid3D( solid, getMaterials(solid.getFaces().length) );
  }

  private Materials[] getMaterials(int numberOfFaces)
  {
    Materials[] materials = new Materials[ numberOfFaces ];

    for( int i = 0 ; i < numberOfFaces; ++i )
    {
      materials[ i ] = _materials1;
    }

    return materials;
  }
}