package liaquay.graphics;

import liaquay.collection.*;

public class Selection
{
  private HashSet _selections = new HashSet();
  private boolean _multiple = false;

  public void multiple()
  {
    _multiple = true;
  }

  public void single()
  {
    _multiple = false;
  }

  public void clearSelection()
  {
    for( Iterator i = _selections.iterator(); i.hasNext(); )
    {
      SelectionListener selectionListener = (SelectionListener)i.next();
      selectionListener.deselected( this );
    }
    _selections.removeAll();
  }

  public void clearSelection( SelectionListener selectionListener )
  {
    _selections.remove( selectionListener );
    selectionListener.deselected( this );
  }

  public boolean isSelected( SelectionListener selectionListener )
  {
    if( selectionListener == null )
    {
      return false;
    }
    else
    {
      return _selections.contains( selectionListener );
    }
  }

  public void select( SelectionListener selectionListener )
  {
    if( selectionListener == null )
    {
      clearSelection();
    }
    else
    {
      if( _multiple )
      {
        if( isSelected( selectionListener ) )
        {
          clearSelection( selectionListener );
        }
        else
        {
          _selections.add( selectionListener );

          selectionListener.selected( this );
        }
      }
      else
      {
        if( isSelected( selectionListener ) )
        {
          clearSelection( selectionListener );
        }
        else
        {
          clearSelection();

          _selections.add( selectionListener );

          selectionListener.selected( this );
        }
      }
    }
  }

  public Iterator iterator()
  {
    return _selections.iterator();
  }

}
