package liaquay.graphics;

import liaquay.math.vector.*;

public class TranslucentSphere3D extends OpaqueSphere3D
{
  private Materials _innerMaterials;
  private double _refractiveIndex;
  private float _translucency;

  public TranslucentSphere3D( Sphere3D sphere,
                              Materials outerMaterials,
                              Materials innerMaterials,
                              double refractiveIndex,
                              float translucency )
  {
    super( sphere, outerMaterials );
    _innerMaterials = innerMaterials;
    _refractiveIndex = refractiveIndex;
    _translucency  = translucency;
  }

  public Materials getInnerMaterials()
  {
    return _innerMaterials;
  }

  public double getRefractiveIndex()
  {
    return _refractiveIndex;
  }

  public float getTranslucency()
  {
    return _translucency;
  }
}
