package liaquay.graphics;

import liaquay.collection.*;

import java.awt.Image;
import java.awt.Toolkit;
import java.awt.image.MemoryImageSource;
import java.awt.image.ColorModel;
import java.awt.image.DirectColorModel;

public class ZBufferArrayImage extends ArrayImage
{
  private int _zBuffer[];

  public ZBufferArrayImage( int width, int height )
  {
    super( width, height );

    _zBuffer = new int[ width * height ];
  }

  public void clear( int color )
  {
    super.clear( color );
    Arrays.fill( _zBuffer, 0 );
  }

  public final void setZ( int x, int y, int z )
  {
    _zBuffer[ ( getWidth() * y ) + x ] = z;
  }

  public final int getZ( int x, int y )
  {
    return _zBuffer[ ( getWidth() * y ) + x ];
  }

  public final int[] getZBuffer()
  {
    return _zBuffer;
  }
}
