package liaquay.graphics.concave;

import liaquay.math.vector.Vector3D;

public class Light
{
  public Vector3D v;
  public int diffuse=0;
  public int specular=0;
  public int highlightSheen=0;
  public int highlightSpread=0;

  private Light()
  // Default constructor not accessible
  {
  }

  public Light(Vector3D direction)
  {
    v = direction.normalize();
  }

  public Light(Vector3D direction,int diffuse)
  {
    v = direction.normalize();
    this.diffuse=diffuse;
  }

  public Light(Vector3D direction, int color, int highlightSheen, int highlightSpread)
  {
    v = direction.normalize();
    this.diffuse=color;
    this.specular=color;
    this.highlightSheen=highlightSheen;
    this.highlightSpread=highlightSpread;
  }

  public Light(Vector3D direction, int diffuse, int specular, int highlightSheen, int highlightSpread)
  {
    v = direction.normalize();
    this.diffuse=diffuse;
    this.specular=specular;
    this.highlightSheen=highlightSheen;
    this.highlightSpread=highlightSpread;
  }
}
