package liaquay.graphics.convex;

import java.awt.*;

import liaquay.math.vector.*;
import liaquay.graphics.*;

public class OpaqueSphere3DRenderer implements Renderer
{
  public void render( Object o,
                      Graphics g,
                      Matrix4x3 combinedTransform,
                      double ppb,
                      int width,
                      int height,
                      int screenX,
                      int screenY,
                      int screenR )
  {
    OpaqueSphere3D sphere = (OpaqueSphere3D)o;

    int r = screenR;

    if( r < 2 ) r = 2;

    g.setColor( sphere.getOuterMaterials().getPlainMaterial().getColor( 1.0f ) );

    int x = screenX - r;
    int y = screenY - r;

    g.fillOval( x,y,r*2,r*2 );
  }
}