package liaquay.graphics.convex.test;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import liaquay.math.vector.*;
import liaquay.graphics.*;
import liaquay.graphics.material.*;
import liaquay.graphics.convex.*;
import liaquay.graphics.raytrace.*;

public class ConvexGraphicsApplet extends Applet
{
  private Image rayImage = null;
  private Graphics3D graphics3D = null;

  public void init()
  {
    setLayout( new BorderLayout() );

    Dimension size = getSize();

    int width = size.width;
    int height = size.height;

    rayImage = createImage( width, height );
    Selection selection = new Selection();
    graphics3D = new ConvexGraphics3D( rayImage, selection );
    //graphics3D = new RayTraceGraphics3D( rayImage, 1, 3 );

    add( new ImageCanvas(rayImage), BorderLayout.CENTER );

    graphics3D.beginScene( new Camera3D( Transform.createIdentity(), 1.0 ) );

    PlainMaterial material1 = new PlainMaterial( new Colour( 1f,1f,0f ),
                                                 new Colour( 0f,0f,0f ),
                                                 1f );

    Materials materials1 = new Materials( material1 );

    OpaqueSphere3D sphere1 = new OpaqueSphere3D( new Sphere3D( 30, new Vector3D( 0,-40,120 ) ),
                                                 materials1 );

    graphics3D.add( sphere1, Transform.createIdentity(), null );
    //graphics3D.add( plane2,  Transform.createIdentity() );
    graphics3D.add( CobraIII.create(),  Transform.createRotateTranslate(.4,.4,0,0,0,250), null );
    graphics3D.add( CobraIII.create(),  Transform.createRotateTranslate(.7,.1,0,-90,100,500), null );

    new Thread()
    {
      public void run()
      {
        graphics3D.endScene();
      }
    }.start();
  }
}