package liaquay.graphics.parser;

import liaquay.text.parser.*;
import liaquay.graphics.*;

public class ParseColour extends ParseSequence
{
  private ParseFloatingPoint _r = new ParseFloatingPoint();
  private ParseFloatingPoint _g = new ParseFloatingPoint();
  private ParseFloatingPoint _b = new ParseFloatingPoint();

  public ParseColour()
  {
    add( new ParseCharLiteral( '(' ) );
    add( new ParseWhiteSpace() );
    add( _r );
    add( new ParseWhiteSpace() );
    add( _g );
    add( new ParseWhiteSpace() );
    add( _b );
    add( new ParseWhiteSpace() );
    add( new ParseCharLiteral( ')' ) );
  }

  public Colour getColour()
  {
    return new Colour( (float)_r.value(), (float)_g.value(), (float)_b.value() );
  }
}