package liaquay.graphics.parser;

import liaquay.text.parser.*;

import liaquay.collection.*;
import liaquay.graphics.*;

import java.io.*;

public class ParseMaterialsList extends ParseSequence
{
  ParseZeroOrMore _materialsParsers = null;

  public ParseMaterialsList()
  {
    setKeepContents( false );
    
    _materialsParsers = new ParseZeroOrMore(
        new ParserFactory() 
        {
          public CharsParser create()
          {
            ParseSequence s1 = new ParseSequence();
            s1.add( new ParseWhiteSpace() );
            s1.add( new ParseMaterials() );
            return s1;
          }
        }
      );    
    
    add( new ParseCharLiteral( '(' ) ); 
    add( _materialsParsers );
    add( new ParseWhiteSpace() );
    add( new ParseCharLiteral( ')' ) );
  }

  public int getNumberOfMaterials()
  {
    return _materialsParsers.getNumberOfParsers();
  }

  public Materials getMaterials( int i )
  {
    ParseSequence s = (ParseSequence)_materialsParsers.getParser( i );
    ParseMaterials w = (ParseMaterials)s.getParser( 1 );
    return w.getMaterials();
  }

  public Materials[] getMaterials()
  {
    Materials[] materials = new Materials[ getNumberOfMaterials() ];
    for( int i = 0; i < getNumberOfMaterials(); ++i )
    {
      materials[ i ] = getMaterials( i );
    }
    return materials;
  }
}
