package liaquay.graphics.parser;

import liaquay.text.parser.*;
import liaquay.math.vector.parser.*;
import liaquay.math.vector.*;
import liaquay.graphics.*;

public class ParseOpaqueSolid3D extends ParseSequence
{
  private ParseSolid3D _solid = new ParseSolid3D();
  private ParseMaterialsList _materials = new ParseMaterialsList();
  private ParsePositiveIntegerSet _materialsIndexed = new ParsePositiveIntegerSet();

  public ParseOpaqueSolid3D()
  {
    add( new ParseCharLiteral( '(' ) );
    add( new ParseWhiteSpace() );
    add( _solid );
    add( new ParseWhiteSpace() );
    add( _materials );
    add( new ParseWhiteSpace() );
    add( _materialsIndexed );
    add( new ParseWhiteSpace() );
    add( new ParseCharLiteral( ')' ) );
  }

  public OpaqueSolid3D getOpaqueSolid3D()
  {
    Solid3D solid = _solid.getSolid3D();

    int numberOfFaces = solid.getFaces().length;

    Materials[] uniqueMaterials = _materials.getMaterials();

    Materials[] materials = new Materials[ numberOfFaces ];

    int[] indexes = _materialsIndexed.getIntegerArray();

    for( int i = 0; i < numberOfFaces; ++i )
    {
      materials[ i ] = uniqueMaterials[ indexes[ i ] ];
    }

    return new OpaqueSolid3D( solid, materials );
  }
}