package liaquay.graphics.parser;

import liaquay.text.parser.*;
import liaquay.graphics.*;

public class ParsePlainMaterial extends ParseSequence
{
  private ParseColour _reflective = new ParseColour();
  private ParseColour _emmisive = new ParseColour();
  private ParseFloatingPoint _reflectivity = new ParseFloatingPoint();

  public ParsePlainMaterial()
  {
    add( new ParseCharLiteral( '(' ) );
    add( new ParseWhiteSpace() );
    add( _reflective );
    add( new ParseWhiteSpace() );
    add( _emmisive );
    add( new ParseWhiteSpace() );
    add( _reflectivity );
    add( new ParseWhiteSpace() );
    add( new ParseCharLiteral( ')' ) );
  }

  public PlainMaterial getPlainMaterial()
  {
    return new PlainMaterial( _reflective.getColour(),
                              _emmisive.getColour(),
                              (float)_reflectivity.value() );
  }
}