package liaquay.graphics.parser.test;

import java.io.*;
import junit.framework.*;
import liaquay.text.parser.*;
import liaquay.graphics.*;
import liaquay.graphics.parser.*;

/**
 * ParseColour tests.
 */
public class ParseColourTest extends TestCase 
{
  public ParseColourTest(String name) 
  {
    super(name);
  }
  
  protected void setUp() 
  {
  }
  
  public static Test suite() 
  {
    /*
     * the dynamic way
     */
    return new TestSuite(ParseColourTest.class);
  }
  
  
  public void test1()
  {
    ParseColour parser = new ParseColour();

    try
    {
      CharArrayReader inputStream = new CharArrayReader(
        new String( "(0.1 0.2 0.3)" ).toCharArray() );

      CharReader reader = new CharReader( inputStream );

      parser.parseSequential( reader );

      if( parser.getMatched() )
      {
        Colour c = parser.getColour();
        
        if( c.getRed() != 0.1f ) fail( "Red component incorrect " + c.getRed() );
        if( c.getGreen() != 0.2f ) fail( "Green component incorrect " + c.getGreen() );
        if( c.getBlue() != 0.3f ) fail( "Blue component incorrect " + c.getBlue() );
      }
      else
      {
        fail( "Could not parse input string\n" + parser.explain() );
      }      
    }
    catch( Exception e )
    {
      fail( "Could not parse input string\n" + parser.explain() );
    }  
  }
}
