package liaquay.graphics.raytrace;

import liaquay.collection.*;
import liaquay.math.vector.*;

public class IntersectionComparator implements ObjectComparator
{
  private Vector3D _start;

  public IntersectionComparator( Vector3D start )
  {
    _start = start;
  }

  public int compare( Object o1, Object o2 )
  {
    TranslucentPolygonIntersection i1 = (TranslucentPolygonIntersection)o1;
    TranslucentPolygonIntersection i2 = (TranslucentPolygonIntersection)o2;

    Vector3D v1 = i1.getIntersection();
    Vector3D v2 = i2.getIntersection();

    double d1 = ( v1.sub( _start ) ).lengthSquared();
    double d2 = ( v2.sub( _start ) ).lengthSquared();

    if( d1 < d2 ) return -1;
    if( d1 > d2 ) return +1;
    return 0;
  }
}