package liaquay.graphics.raytrace;

import java.awt.*;

public class RayColour
{
  private double _red;
  private double _green;
  private double _blue;

  public RayColour()
  {
    _red = 0;
    _green = 0;
    _blue = 0;
  }
  
  public RayColour( double red, double green, double blue )
  {
    _red = red;
    _green = green;
    _blue = blue;
  }
  
  public RayColour( RayColour c )
  {
    _red = c._red;
    _green = c._green;
    _blue = c._blue;
  }
  
  
  public RayColour( RayColour c,
                    RayColour i1, double a1, 
                    RayColour i2, double a2 )
  {
    _red = c._red * ( ( i1._red * a1 ) + ( i2._red * a2 ) );
    _green = c._green * ( ( i1._green * a1 ) + ( i2._green * a2 ) );
    _blue = c._blue * ( ( i1._blue * a1 ) + ( i2._blue * a2 ) );
  }  
  
  public RayColour( Color c )
  {
    _red = (double)c.getRed() / 255;
    _green = (double)c.getGreen() / 255;
    _blue = (double)c.getBlue() / 255;
  }  
  
  public double getRed()
  {
    return _red;
  }
  
  public double getGreen()
  {
    return _green;
  }
  
  public double getBlue()
  {
    return _blue;
  }
   
  public Color getColor()
  {
    return new Color( (float)_red, (float)_green, (float)_blue );
  }
}