package liaquay.graphics.raytrace.test;

import java.io.*;
import junit.framework.*;

import liaquay.graphics.raytrace.*;
import liaquay.collection.*;
import liaquay.math.vector.*;

/**
 * IntersectionComparator tests.
 */
public class IntersectionComparatorTest extends TestCase
{
  public IntersectionComparatorTest(String name)
  {
    super(name);
  }

  protected void setUp()
  {
  }

  public static Test suite()
  {
    /*
     * the dynamic way
     */
    return new TestSuite(IntersectionComparatorTest.class);
  }

  public static void main (String[] args)
  {
    junit.textui.TestRunner.run (suite());
  }

  public void test1()
  {
    Sorter sorter = new QuickSorter();
    ArrayList list = new ArrayList();
    Vector3D start = new Vector3D( 5,5,5 );
    Vector3D v0 = new Vector3D( 6,6,6 );
    Vector3D v1 = new Vector3D( 7,7,7 );
    Vector3D v2 = new Vector3D( 7,7,8 );
    TranslucentPolygonIntersection i0 = new TranslucentPolygonIntersection( null, v0 );
    TranslucentPolygonIntersection i1 = new TranslucentPolygonIntersection( null, v1 );
    TranslucentPolygonIntersection i2 = new TranslucentPolygonIntersection( null, v2 );
    list.add( i2 );
    list.add( i0 );
    list.add( i1 );


    // Order the intersections in terms of distance from start
    SortableObjectArray sortable = new SortableObjectArray( list, new IntersectionComparator( start ) );

    sorter.sort( sortable );

    assertEquals( i0, list.get( 0 ) );
    assertEquals( i1, list.get( 1 ) );
    assertEquals( i2, list.get( 2 ) );
  }

}