package liaquay.graphics.wireframe.test;

import liaquay.graphics.*;
import liaquay.math.vector.*;

public class CobraIII
{
  public static OpaqueSolid3D create()
  {
/*
    ((0.5647059 0.6901961 0.3137255 0.0 0.0 0.0)(1 0 2))
    ((0.5568628 0.78431374 0.21960784 0.0 0.0 0.0)(5 1 2))
    ((0.5568628 0.78431374 0.21960784 0.0 0.0 0.0)(2 0 6))
    ((0.47058824 0.6039216 0.27450982 0.0 0.0 0.0)(3 1 5))
    ((0.47058824 0.6039216 0.27450982 0.0 0.0 0.0)(6 0 4))
    ((0.9098039 0.9529412 0.8039216 0.0 0.0 0.0)(5 2 9))
    ((0.9098039 0.9529412 0.8039216 0.0 0.0 0.0)(9 2 6))
    ((0.7019608 0.76862746 0.6117647 0.0 0.0 0.0)(8 3 5))
    ((0.7019608 0.76862746 0.6117647 0.0 0.0 0.0)(6 4 7))
    ((0.48235294 0.52156866 0.35686275 0.0 0.0 0.0)(7 11 10 8 5 9 6))
    ((0.9372549 0.9490196 0.93333334 0.0 0.0 0.0)(10 1 3 8))
    ((0.33333334 0.4117647 0.21568628 0.0 0.0 0.0)(10 11 0 1))
    ((0.9372549 0.9490196 0.93333334 0.0 0.0 0.0)(7 4 0 11))
    ((0.2 0.2 0.2 1.0 0.0 0.0)(17 14 15 16))
    ((0.2 0.2 0.2 1.0 0.0 0.0)(19 12 13 18))
    ((0.2 0.2 0.2 1.0 0.0 0.0)(23 22 24))
    ((0.2 0.2 0.2 1.0 0.0 0.0)(27 25 26))
*/

    PlainMaterial material1 = new PlainMaterial( new Colour( 1.00f, 0.75f, 0.75f ),
                                                 new Colour( 0f,0f,0f ),
                                                 0f );

    PlainMaterial material2 = new PlainMaterial( new Colour( 0.75f, 1.00f, 0.75f ),
                                                 new Colour( 0f,0f,0f ),
                                                 0f );

    PlainMaterial material3 = new PlainMaterial( new Colour( 0.75f, 0.75f, 1.00f ),
                                                 new Colour( 0f,0f,0f ),
                                                 0f );

    PlainMaterial material4 = new PlainMaterial( new Colour( 0.00f, 0.0f, 0.00f ),
                                                 new Colour( 1.0f,0f,0f ),
                                                 0f );

    Materials materials1 = new Materials( material1 );
    Materials materials2 = new Materials( material2 );
    Materials materials3 = new Materials( material3 );
    Materials materials4 = new Materials( material4 );

    return create( materials1, materials2, materials3, materials4 );
  }

  public static OpaqueSolid3D create( Materials materials1,
                                      Materials materials2,
                                      Materials materials3,
                                      Materials materials4 )
  {
    Vector3D[] vertices =
    {
      new Vector3D(  32.0,   0.0,  76.0 ),
      new Vector3D( -32.0,   0.0,  76.0 ),
      new Vector3D(   0.0,  26.0,  24.0 ),
      new Vector3D(-120.0,  -3.0,  -8.0 ),
      new Vector3D( 120.0,  -3.0,  -8.0 ),
      new Vector3D( -88.0,  16.0, -40.0 ),
      new Vector3D(  88.0,  16.0, -40.0 ),
      new Vector3D( 128.0,  -8.0, -40.0 ),
      new Vector3D(-128.0,  -8.0, -40.0 ),
      new Vector3D(   0.0,  26.0, -40.0 ),
      new Vector3D( -32.0, -24.0, -40.0 ),
      new Vector3D(  32.0, -24.0, -40.0 ),
      new Vector3D( -36.0,   8.0, -40.0 ),
      new Vector3D(  -8.0,  12.0, -40.0 ),
      new Vector3D(   8.0,  12.0, -40.0 ),
      new Vector3D(  36.0,   8.0, -40.0 ),
      new Vector3D(  36.0, -12.0, -40.0 ),
      new Vector3D(   8.0, -16.0, -40.0 ),
      new Vector3D(  -8.0, -16.0, -40.0 ),
      new Vector3D( -36.0, -12.0, -40.0 ),
      new Vector3D(   0.0,   0.0,  76.0 ),
      new Vector3D(   0.0,   0.0,  90.0 ),
      new Vector3D( -80.0,  -6.0, -40.0 ),
      new Vector3D( -80.0,   6.0, -40.0 ),
      new Vector3D( -88.0,   0.0, -40.0 ),
      new Vector3D(  80.0,   6.0, -40.0 ),
      new Vector3D(  88.0,   0.0, -40.0 ),
      new Vector3D(  80.0,  -6.0, -40.0 )
    };

    Solid3DFace[] faces =
    {
      new Solid3DFace( new int[] { 1, 0, 2 } ),
      new Solid3DFace( new int[] { 5, 1, 2 } ),
      new Solid3DFace( new int[] { 2, 0, 6 } ),
      new Solid3DFace( new int[] { 3, 1, 5 } ),
      new Solid3DFace( new int[] { 6, 0, 4 } ),
      new Solid3DFace( new int[] { 5, 2, 9 } ),
      new Solid3DFace( new int[] { 9, 2, 6 } ),
      new Solid3DFace( new int[] { 8, 3, 5 } ),
      new Solid3DFace( new int[] { 6, 4, 7 } ),
      new Solid3DFace( new int[] { 7, 11, 10, 8, 5, 9, 6 } ),
      new Solid3DFace( new int[] { 10, 1, 3, 8 } ),
      new Solid3DFace( new int[] { 10, 11, 0, 1 } ),
      new Solid3DFace( new int[] { 7, 4, 0, 11 } ),
      new Solid3DFace( new int[] { 17, 14, 15, 16 } ),
      new Solid3DFace( new int[] { 19, 12, 13, 18 } ),
      new Solid3DFace( new int[] { 23, 22, 24 } ),
      new Solid3DFace( new int[] { 27, 25, 26 } ),
    };

    PlainMaterial material1 = new PlainMaterial( new Colour( 1.00f, 0.75f, 0.75f ),
                                                 new Colour( 0f,0f,0f ),
                                                 0f );

    PlainMaterial material2 = new PlainMaterial( new Colour( 0.75f, 1.00f, 0.75f ),
                                                 new Colour( 0f,0f,0f ),
                                                 0f );

    PlainMaterial material3 = new PlainMaterial( new Colour( 0.75f, 0.75f, 1.00f ),
                                                 new Colour( 0f,0f,0f ),
                                                 0f );

    PlainMaterial material4 = new PlainMaterial( new Colour( 1.00f, 0.75f, 1.00f ),
                                                 new Colour( 0f,0f,0f ),
                                                 0f );



    Materials[] materials =
    {
      materials1,
      materials1,
      materials1,
      materials1,
      materials1,
      materials1,
      materials1,
      materials1,
      materials1,
      materials2,
      materials2,
      materials2,
      materials2,
      materials4,
      materials4,
      materials4,
      materials4
    };

    Solid3D solid = new Solid3D( vertices, faces );

    return new OpaqueSolid3D( solid, materials );
  }
}