package liaquay.math.set;

public class ByteBijection
{
  private byte[] _map;

  private static int byteToIndex( byte b )
  {
    return b & 0xff;
  }

  private static byte indexToByte( int i )
  {
    return (byte)i;
  }

  public ByteBijection()
  {
    _map = new byte[ 256 ];

    for( int i = 0; i < 256; ++i )
    {
      _map[ i ] = indexToByte( i );
    }
  }

  public ByteBijection( byte[] map ) throws NotABijectionException
  {
    _map = map;

    boolean[] flags = new boolean[ _map.length ];

    for( int i = 0; i < _map.length; ++i )
    {
      int index = byteToIndex( map[ i ] );

      if( index >= _map.length )
      {
        throw new NotABijectionException();
      }

      if( flags[ index ] == true )
      {
        throw new NotABijectionException();
      }

      flags[ index ] = true;
    }
  }

  public byte map( byte b )
  {
    return _map[ byteToIndex( b ) ];
  }

  public ByteBijection inverse()
  {
    byte[] map = new byte[ _map.length ];

    for( int i = 0; i < _map.length; ++i )
    {
      map[ byteToIndex( _map[ i ] ) ] = indexToByte( i );
    }

    try
    {
      return new ByteBijection( map );
    }
    catch( NotABijectionException e )
    {
      // Should never happen
      throw new RuntimeException( "Problem inverting bijectin" );
    }
  }

}