package liaquay.math.set;

/**
 * A bijection for positive integers.
 */
public class IntegerBijection
{
  private int[] _map;


  public IntegerBijection( int size )
  {
    _map = new int[ size ];

    for( int i = 0; i < size; ++i )
    {
      _map[ i ] = i;
    }
  }

  public int size()
  {
    return _map.length;
  }

  public IntegerBijection( int[] map ) throws NotABijectionException
  {
    _map = map;

    boolean[] flags = new boolean[ _map.length ];

    for( int i = 0; i < _map.length; ++i )
    {
      int index = map[ i ];

      if( index >= _map.length )
      {
        throw new NotABijectionException();
      }

      if( flags[ index ] == true )
      {
        throw new NotABijectionException();
      }
      flags[ index ] = true;
    }
  }

  public int map( int i )
  {
    return _map[ i ];
  }

  public IntegerBijection inverse()
  {
    int[] map = new int[ _map.length ];

    for( int i = 0; i < _map.length; ++i )
    {
      map[ _map[ i ] ] = i;
    }

    try
    {
      return new IntegerBijection( map );
    }
    catch( NotABijectionException e )
    {
      // Should never happen
      throw new RuntimeException( "Problem inverting bijectin" );
    }
  }

  public void swap( int i, int j )
  {
    int t = _map[ i ];
    _map[ i ] = _map[ j ];
    _map[ j ] = t;
  }
}