package liaquay.math.vector;

/**
 * Representation of a line in 3-dimentional space.
 */
public class Line3D
{
  // A point on the line
  private Vector3D _point;

  // The direction of the line.
  private Vector3D _direction;

  /**
   * Constructs a line in 3-dimentional space.
   * @param point a point on the line.
   * @param direction the direction of the line.
   */
  public Line3D( Vector3D point, Vector3D direction )
  {
    _point = point;
    _direction = direction;
  }

  /**
   * Gets the point this line was defined with.
   * @return The point this line was defined with.
   */
  public Vector3D getPoint()
  {
    return _point;
  }

  /**
   * Gets the direction this line was defined with.
   * @return The direction this line was defined with.
   */
  public Vector3D getDirection()
  {
    return _direction;
  }
}
