package liaquay.math.vector;

import liaquay.collection.*;

public class Solid3DBuilder
{
  private ArrayList _vertices = new ArrayList();
  private ArrayList _faces = new ArrayList();

  public void addVertex( Vector3D vertex )
  {
    _vertices.add( vertex );
  }

  public void addFace( Solid3DFace face )
  {
    _faces.add( face );
  }

  public Solid3D buildSolid3D()
  {
    return new Solid3D( getVertices(), getFaces() );
  }

  private Vector3D[] getVertices()
  {
    Vector3D[] vertices = new Vector3D[ _vertices.size() ];

    for( int i = 0; i < _vertices.size(); ++i )
    {
      vertices[ i ] = (Vector3D)_vertices.get( i );
    }

    return vertices;
  }

  private Solid3DFace[] getFaces()
  {
    Solid3DFace[] faces = new Solid3DFace[ _faces.size() ];

    for( int i = 0; i < _faces.size(); ++i )
    {
      faces[ i ] = (Solid3DFace)_faces.get( i );
    }

    return faces;
  }
}
