package liaquay.math.vector;

public class Solid3DFace
{
  private int _vertices[];

  public Solid3DFace( int[] vertices )
  {
    _vertices = vertices;
  }

  public final int[] getVertices()
  {
    return _vertices;
  }

  public Vector3D calculateNormal( Vector3D[] v )
  {
    Vector3D v1 = v[ _vertices[ 1 ] ].sub( v[ _vertices[ 0 ] ] );
    Vector3D v2 = v[ _vertices[ 2 ] ].sub( v[ _vertices[ 1 ] ] );
    return v2.cross( v1 ).normalize();
  }

  public Vector3D calculateCenter( Vector3D[] m )
  {
    double newValues[] = new double[ 3 ];
    newValues[ 0 ] = 0;
    newValues[ 1 ] = 0;
    newValues[ 2 ] = 0;

    for( int i = 0; i < _vertices.length; ++i )
    {
      double v[] = m[ i ].getValues();

      newValues[ 0 ] += v [ 0 ];
      newValues[ 1 ] += v [ 1 ];
      newValues[ 2 ] += v [ 2 ];
    }

    newValues[ 0 ] /= _vertices.length;
    newValues[ 1 ] /= _vertices.length;
    newValues[ 2 ] /= _vertices.length;

    return new Vector3D( newValues );
  }

  public String toString( Vector3D[] v )
  {
    Vector3D v1 = v[ _vertices[ 1 ] ].sub( v[ _vertices[ 0 ] ] );
    Vector3D v2 = v[ _vertices[ 2 ] ].sub( v[ _vertices[ 1 ] ] );
    Vector3D normal = v2.cross( v1 ).normalize();

    StringBuffer sb = new StringBuffer();
    sb.append( "(" );

    for( int i = 0; i < _vertices.length; ++i )
    {
      sb.append( _vertices[ i ] );
      if( i < _vertices.length - 1 )
      {
        sb.append( " " );
      }
    }
    sb.append( ")" );

    return sb.toString();
  }
}