package liaquay.math.vector.parser;

import liaquay.text.parser.*;
import liaquay.math.vector.*;

public class ParseSolid3D extends ParseSequence
{
  private ParseVertices3D _vertices = new ParseVertices3D();
  private ParseSolid3DFaces _faces = new ParseSolid3DFaces();

  public ParseSolid3D()
  {
    setKeepContents( false );

    add( new ParseWhiteSpace() );
    add( new ParseCharLiteral( '(' ) );
    add( new ParseWhiteSpace() );
    add( _vertices );
    add( new ParseWhiteSpace() );
    add( _faces );
    add( new ParseWhiteSpace() );
    add( new ParseCharLiteral( ')' ) );
  }

  public Solid3D getSolid3D()
  {
    Vector3D[] vertices = _vertices.getVertices();
    Solid3DFace[] faces = _faces.getSolid3DFaces();
    Solid3D solid = new Solid3D( vertices, faces );
    return solid;
  }
}
