package liaquay.math.vector.parser;

import liaquay.collection.*;
import liaquay.text.parser.*;
import liaquay.math.vector.*;

import java.io.*;

public class ParseSolid3DFaces extends ParseSequence
{
  ParseZeroOrMore _faceParsers = null;

  public ParseSolid3DFaces()
  {
    setKeepContents( false );
    
    _faceParsers = new ParseZeroOrMore(
        new ParserFactory() 
        {
          public CharsParser create()
          {
            ParseSequence s1 = new ParseSequence();
            s1.add( new ParseWhiteSpace() );
            s1.add( new ParseSolid3DFace() );
            return s1;
          }
        }
      );    
    
    add( new ParseCharLiteral( '(' ) ); 
    add( _faceParsers );
    add( new ParseWhiteSpace() );
    add( new ParseCharLiteral( ')' ) );
  }

  public int getNumberOfFaces()
  {
    return _faceParsers.getNumberOfParsers();
  }

  public Solid3DFace getSolid3DFace( int i )
  {
    ParseSequence s = (ParseSequence)_faceParsers.getParser( i );
    ParseSolid3DFace w = (ParseSolid3DFace)s.getParser( 1 );
    return w.getSolid3DFace();
  }

  public Solid3DFace[] getSolid3DFaces()
  {
    Solid3DFace[] faces = new Solid3DFace[ getNumberOfFaces() ];
    for( int i = 0; i < getNumberOfFaces(); ++i )
    {
      faces[ i ] = getSolid3DFace( i );
    }
    return faces;
  }
}
