package liaquay.math.vector.parser;

import liaquay.text.parser.*;
import liaquay.math.vector.*;

public class ParseVector2D extends ParseSequence
{
  private ParseFloatingPoint _x = new ParseFloatingPoint();
  private ParseFloatingPoint _y = new ParseFloatingPoint();

  public ParseVector2D()
  {
    add( new ParseCharLiteral( '(' ) );
    add( new ParseWhiteSpace() );
    add( _x );
    add( new ParseWhiteSpace() );
    add( _y );
    add( new ParseWhiteSpace() );
    add( new ParseCharLiteral( ')' ) );
  }

  public double getX()
  {
    return _x.value();
  }

  public double getY()
  {
    return _y.value();
  }

  public double[] getValue()
  {
    double[] v = new double[ 2 ];
    v[ 0 ] = getX();
    v[ 1 ] = getY();
    return v;
  }

  public Vector2D getVector2D()
  {
    return new Vector2D( getX(), getY() );
  }
}