package liaquay.math.vector.parser;

import liaquay.text.parser.*;
import liaquay.math.vector.*;

public class ParseVector3D extends ParseSequence
{
  private ParseFloatingPoint _x = new ParseFloatingPoint();
  private ParseFloatingPoint _y = new ParseFloatingPoint();
  private ParseFloatingPoint _z = new ParseFloatingPoint();

  public ParseVector3D()
  {
    add( new ParseCharLiteral( '(' ) );
    add( new ParseWhiteSpace() );
    add( _x );
    add( new ParseWhiteSpace() );
    add( _y );
    add( new ParseWhiteSpace() );
    add( _z );
    add( new ParseWhiteSpace() );
    add( new ParseCharLiteral( ')' ) );
  }

  public double getX()
  {
    return _x.value();
  }

  public double getY()
  {
    return _y.value();
  }

  public double getZ()
  {
    return _z.value();
  }
  
  public Vector3D getVector3D()
  {
    return new Vector3D( getX(), getY(), getZ() );
  }
}
