package liaquay.math.vector.parser;

import liaquay.collection.*;
import liaquay.text.parser.*;
import liaquay.math.vector.*;

import java.io.*;

public class ParseVertices3D extends ParseSequence
{
  ParseZeroOrMore _vertexParsers = null;

  public ParseVertices3D()
  {
    setKeepContents( false );
    
    _vertexParsers = new ParseZeroOrMore(
        new ParserFactory() 
        {
          public CharsParser create()
          {
            ParseSequence s1 = new ParseSequence();
            s1.add( new ParseWhiteSpace() );
            s1.add( new ParseVector3D() );
            return s1;
          }
        }
      );    
    
    add( new ParseCharLiteral( '(' ) ); 
    add( _vertexParsers );
    add( new ParseWhiteSpace() );
    add( new ParseCharLiteral( ')' ) );
  }

  public int getNumberOfVertices()
  {
    return _vertexParsers.getNumberOfParsers();
  }

  public Vector3D getVector3D( int i )
  {
    ParseSequence s = (ParseSequence)_vertexParsers.getParser( i );
    ParseVector3D w = (ParseVector3D)s.getParser( 1 );
    return w.getVector3D();
  }

  public Vector3D[] getVertices()
  {
    Vector3D[] vertices = new Vector3D[ getNumberOfVertices() ];
    for( int i = 0; i < getNumberOfVertices(); ++i )
    {
      vertices[ i ] = getVector3D( i );
    }
    return vertices;
  }
}
