package liaquay.math.vector.parser.test;

import java.io.*;
import junit.framework.*;
import liaquay.text.parser.*;
import liaquay.math.vector.*;
import liaquay.math.vector.parser.*;

/**
 * ParseSolid3DFace tests.
 */
public class ParseSolid3DFaceTest extends TestCase 
{
  public ParseSolid3DFaceTest(String name) 
  {
    super(name);
  }
  
  protected void setUp() 
  {
  }
  
  public static Test suite() 
  {
    /*
     * the dynamic way
     */
    return new TestSuite(ParseSolid3DFaceTest.class);
  }
  
  
  public void test1()
  {
    ParseSolid3DFace parser = new ParseSolid3DFace();

    try
    {
      CharArrayReader inputStream = new CharArrayReader(
        new String( "(1 2 3 4)" ).toCharArray() );

      CharReader reader = new CharReader( inputStream );

      parser.parseSequential( reader );

      if( parser.getMatched() )
      {
        Solid3DFace face = parser.getSolid3DFace();
        
        int[] vertices = face.getVertices();
        assertEquals( vertices[ 0 ], 1 );
        assertEquals( vertices[ 1 ], 2 );
        assertEquals( vertices[ 2 ], 3 );
        assertEquals( vertices[ 3 ], 4 );
      }
      else
      {
        fail( "Could not parse input string\n" + parser.explain() );
      }      
    }
    catch( Exception e )
    {
      fail( "Could not parse input string\n" + parser.explain() );
    }  
  }
}
