package liaquay.math.vector.parser.test;

import java.io.*;
import junit.framework.*;
import liaquay.text.parser.*;
import liaquay.math.vector.*;
import liaquay.math.vector.parser.*;

/**
 * ParseSolid3DFace tests.
 */
public class ParseSolid3DFacesTest extends TestCase 
{
  public ParseSolid3DFacesTest(String name) 
  {
    super(name);
  }
  
  protected void setUp() 
  {
  }
  
  public static Test suite() 
  {
    /*
     * the dynamic way
     */
    return new TestSuite(ParseSolid3DFacesTest.class);
  }
  
  
  public void test1()
  {
    ParseSolid3DFaces parser = new ParseSolid3DFaces();

    try
    {
      CharArrayReader inputStream = new CharArrayReader(
        new String( "((1 2 3 4) (5  6  7) )" ).toCharArray() );

      CharReader reader = new CharReader( inputStream );

      parser.parseSequential( reader );

      if( parser.getMatched() )
      {
        Solid3DFace[] faces = parser.getSolid3DFaces();

        Solid3DFace face1 = faces[ 0 ];
        Solid3DFace face2 = faces[ 1 ];
        
        int[] vertices1 = face1.getVertices();
        int[] vertices2 = face2.getVertices();
        
        assertEquals( vertices1[ 0 ], 1 );
        assertEquals( vertices1[ 1 ], 2 );
        assertEquals( vertices1[ 2 ], 3 );
        assertEquals( vertices1[ 3 ], 4 );

        assertEquals( vertices2[ 0 ], 5 );
        assertEquals( vertices2[ 1 ], 6 );
        assertEquals( vertices2[ 2 ], 7 );
      }
      else
      {
        fail( "Could not parse input string\n" + parser.explain() );
      }      
    }
    catch( Exception e )
    {
      fail( "Could not parse input string\n" + parser.explain() );
    }  
  }
}
