package liaquay.math.vector.parser.test;

import java.io.*;
import junit.framework.*;
import liaquay.text.parser.*;
import liaquay.math.vector.*;
import liaquay.math.vector.parser.*;

/**
 * ParseSolid3DFace tests.
 */
public class ParseSolid3DTest extends TestCase 
{
  public ParseSolid3DTest(String name) 
  {
    super(name);
  }
  
  protected void setUp() 
  {
  }
  
  public static Test suite() 
  {
    /*
     * the dynamic way
     */
    return new TestSuite(ParseSolid3DTest.class);
  }
  
  
  public void test1()
  {
    ParseSolid3D parser = new ParseSolid3D();

    try
    {
      CharArrayReader inputStream = new CharArrayReader(
        new String( 
"  (\n" +
"    (\n" +
"      (160.0 0.0 160.0)\n" +
"      (0.0 160.0 160.0)\n" +
"      (-160.0 0.0 160.0)\n" +
"      (0.0 -160.0 160.0)\n" +
"      (160.0 -160.0 0.0)\n" +
"      (160.0 160.0 0.0)\n" +
"      (-160.0 160.0 0.0)\n" +
"      (-160.0 -160.0 0.0)\n" +
"      (160.0 0.0 -160.0)\n" +
"      (0.0 160.0 -160.0)\n" +
"      (-160.0 0.0 -160.0)\n" +
"      (0.0 -160.0 -160.0)\n" +
"      (10.0 -30.0 160.0)\n" +
"      (10.0 30.0 160.0)\n" +
"      (-10.0 30.0 160.0)\n" +
"      (-10.0 -30.0 160.0)\n" +
"    )\n" +
"    (\n" +
"      (0 1 2 3)\n" +
"      (4 0 3)\n" +
"      (0 5 1)\n" +
"      (1 6 2)\n" +
"      (2 7 3)\n" +
"      (4 3 7 11)\n" +
"      (8 5 0 4)\n" +
"      (10 7 2 6)\n" +
"      (1 5 9 6)\n" +
"      (11 7 10)\n" +
"      (11 8 4)\n" +
"      (9 5 8)\n" +
"      (10 6 9)\n" +
"      (11 10 9 8)\n" +
"      (15 12 13 14)\n" +
"    )\n" +
"  )\n"
      ).toCharArray() );

      CharReader reader = new CharReader( inputStream );

      parser.parseSequential( reader );

      if( parser.getMatched() )
      {

      }
      else
      {
        fail( "Could not parse input string\n" + parser.explain() );
      }      
    }
    catch( Exception e )
    {
      fail( "Could not parse input string\n" + parser.explain() );
    }  
  }
}
