package liaquay.math.vector.parser.test;

import java.io.*;
import junit.framework.*;
import liaquay.text.parser.*;
import liaquay.math.vector.*;
import liaquay.math.vector.parser.*;

/**
 * Transform tests.
 */
public class ParseVector3DTest extends TestCase 
{
  public ParseVector3DTest(String name) 
  {
    super(name);
  }
  
  protected void setUp() 
  {
  }
  
  public static Test suite() 
  {
    /*
     * the dynamic way
     */
    return new TestSuite(ParseVector3DTest.class);
  }

  public void test1()
  {
    ParseVector3D parser = new ParseVector3D();

    try
    {
      CharArrayReader inputStream = new CharArrayReader(
        new String( "( 1.1 2.2 3.3 )" ).toCharArray() );

      CharReader reader = new CharReader( inputStream );

      parser.parseSequential( reader );

      if( parser.getMatched() )
      {
        Vector3D v = new Vector3D( 1.1, 2.2, 3.3 );
        
        assertEquals( parser.getVector3D(), v );
      }
      else
      {
        fail( "Could not parse input string\n" + parser.explain() );
      }      
    }
    catch( Exception e )
    {
      fail( "Could not parse input string\n" + parser.explain() );
    }  
  }
}
