package liaquay.math.vector.parser.test;

import java.io.*;
import junit.framework.*;
import liaquay.text.parser.*;
import liaquay.math.vector.*;
import liaquay.math.vector.parser.*;

/**
 * ParseVertices3DTest tests.
 */
public class ParseVertices3DTest extends TestCase 
{
  public ParseVertices3DTest(String name) 
  {
    super(name);
  }
  
  protected void setUp() 
  {
  }
  
  public static Test suite() 
  {
    /*
     * the dynamic way
     */
    return new TestSuite(ParseVertices3DTest.class);
  }

  public void test1()
  {
    ParseVertices3D parser = new ParseVertices3D();

    try
    {
      parser.parseSequential( "( (1.1 2.2   3.3) ( 4.4 5.5 6.6 ) )" );

      if( parser.getMatched() )
      {
        Vector3D v1 = new Vector3D( 1.1, 2.2, 3.3 );
        Vector3D v2 = new Vector3D( 4.4, 5.5, 6.6 );
        
        Vector3D[] vertices = parser.getVertices();
        
        assertEquals( vertices[ 0 ], v1 );
        assertEquals( vertices[ 1 ], v2 );
      }
      else
      {
        fail( "Could not parse input string\n" + parser.explain() );
      }      
    }
    catch( Exception e )
    {
      fail( "Could not parse input string\n" + parser.explain() );
    }     
  }
}
