package liaquay.math.vector.test;

import junit.framework.*;
import liaquay.math.vector.*;

/**
 * MappedPlane tests.
 */
public class MappedPlaneTest extends TestCase
{
  public MappedPlaneTest(String name)
  {
    super(name);
  }

  protected void setUp()
  {
  }

  public static Test suite()
  {
    /*
     * the dynamic way
     */
    return new TestSuite(MappedPlaneTest.class);
  }

  public static void main (String[] args)
  {
    junit.textui.TestRunner.run (suite());
  }

  public void test1()
  {
    // Create a plane with a normal of (0,0,-1)
    MappedPlane3D plane = new MappedPlane3D( new Vector3D( 0,0,0 ),   // Origin
                                             new Vector3D( 1,0,0 ),   // Point 1
                                             new Vector3D( 0,1,0 ),   // Point 2
                                             false );

    // Create a line towards the plane
    Vector3D start = new Vector3D( 0,0,-2 );
    Vector3D direction = new Vector3D( 0,0,1 );

    // Intersect the line and the plane
    Vector3D intersection = plane.halfLineIntersection( start, direction, 1 );

    if( intersection == null )
    {
      fail( "Could not find intersection" );
    }

    // Intersect the line and the plane
    intersection = plane.halfLineIntersection( start, direction, 3 );

    if( intersection != null )
    {
      fail( "Should not have found intersection" );
    }

    // Intersect the line and the plane
    intersection = plane.halfLineIntersection( start, direction, -1 );

    if( intersection == null )
    {
      fail( "Could not find intersection" );
    }

    // Intersect the line and the plane
    intersection = plane.halfLineIntersection( start, direction, -3 );

    if( intersection == null )
    {
      fail( "Could not find intersection" );
    }

  }

  public void test2()
  {
    // Create a plane with a normal of (0,0,-1)
    MappedPlane3D plane = new MappedPlane3D( new Vector3D( 0,0,0 ),   // Origin
                                             new Vector3D( 1,0,0 ),   // Point 1
                                             new Vector3D( 0,1,0 ),   // Point 2
                                             false );

    // Create a line towards the plane
    Vector3D start = new Vector3D( 0,0,2 );
    Vector3D direction = new Vector3D( 0,0,1 );

    // Intersect the line and the plane
    Vector3D intersection = plane.halfLineIntersection( start, direction, 1 );

    if( intersection != null )
    {
      fail( "Should not have found intersection" );
    }

    // Intersect the line and the plane
    intersection = plane.halfLineIntersection( start, direction, 3 );

    if( intersection != null )
    {
      fail( "Should not have found intersection" );
    }

    // Intersect the line and the plane
    intersection = plane.halfLineIntersection( start, direction, -1 );

    if( intersection != null )
    {
      fail( "Should not have found intersection" );
    }

    // Intersect the line and the plane
    intersection = plane.halfLineIntersection( start, direction, -3 );

    if( intersection == null )
    {
      fail( "Could not find intersection" );
    }

  }


}
