package liaquay.math.vector.test;

import junit.framework.*;
import liaquay.math.vector.*;

/**
 * Transform tests.
 */
public class TransformTest extends TestCase 
{
  public TransformTest(String name) 
  {
    super(name);
  }
  
  protected void setUp() 
  {
  }
  
  public static Test suite() 
  {
    /*
     * the dynamic way
     */
    return new TestSuite(TransformTest.class);
  }

  public void testInverse()
  {
    Transform t1 = new Transform();
    t1.rotateTranslate( 1.0, 0.0, 0.0, 1.0, 4.0, 3.0 );
    
    Transform t2 = t1.inverse();
    
    Transform t3 = t2.mul( t1 );
    
    Vector3D v1 = new Vector3D( 1.0, 0.0, 0.0 );
    
    Matrix4x3 m1 = new Matrix4x3( t3 );
    
    Vector3D v2 = v1.mul( m1 );
    
    Vector3D v3 = v2.sub( v1 );
    
//System.out.println( t1 );
//System.out.println( t2 );
    
    if( v3.length() > 0.0001 )
    {
      fail( "Did not invert transform correctly" );
    }
  }
   
}
