package liaquay.stream;

import java.io.*;

public class BooleanArrayBitOutputStream implements BitOutputStream
{
  private boolean[] _bits = new boolean[ 1024 ];
  private int _index = 0;

  public BooleanArrayBitOutputStream( int size )
  {
    _bits = new boolean[ size ];
  }

  public BooleanArrayBitOutputStream()
  {
    _bits = new boolean[ 1024 ];
  }

  public boolean eof()
  {
    return _index >= _bits.length;
  }

  public void close()
  {
  }
  
  public void write( boolean bit ) throws IOException
  {
    if( _index >= _bits.length )
    {
      boolean[] newBits = new boolean[ _bits.length * 2 ];
      for( int i = 0; i < _index; ++i )
      {
        newBits[ i ] = _bits[ i ];
      }
      _bits = newBits;
    }
    
    _bits[ _index++ ] = bit;
  }
  
  public void write( boolean[] bits ) throws IOException
  {
    for( int i = 0; i < bits.length; ++i )
    {
      write( bits[ i ] );
    }
  }
  
  public boolean[] getBits()
  {
    boolean[] newBits = new boolean[ _index ];
    for( int i = 0; i < _index; ++i )
    {
      newBits[ i ] = _bits[ i ];
    }
    return newBits;
  }
}
