package liaquay.stream;

import java.io.*;

public class ByteArraySeekableByteInputStream implements SeekableByteInputStream
{
  private byte[] _bytes;
  private int _offset = 0;
  private boolean _open = true;

  public ByteArraySeekableByteInputStream( byte[] bytes )
  {
    _bytes = bytes;
  }

  public byte read() throws IOException
  {
    if( eof() ) throw new IOException( "Read off end of stream " + _offset );

    return ( _bytes[ _offset++ ] );
  }

  public boolean eof() throws IOException
  {
    return _offset == _bytes.length;
  }

  public void close()
  {
    _open = false;
  }

  public void seek( long index ) throws IOException
  {
    if( index > _bytes.length ) throw new IOException( "Seek off end of stream " + index );
    if( index < 0 ) throw new IOException( "Seek off start of stream " + index );
    _offset = (int)index;
  }

  public long getCurrentIndex()
  {
    return (long)_offset;
  }
}
