package liaquay.stream;

import java.io.*;

public class FileSeekableByteInputStream implements ByteInputStream, SeekableByteInputStream
{
  private RandomAccessFile _file;
  private long _length;

  public FileSeekableByteInputStream( RandomAccessFile file ) throws IOException
  {
    _file = file;
    _length = _file.length();
  }

  public FileSeekableByteInputStream( String filename ) throws IOException
  {
    _file = new RandomAccessFile( filename, "r" );
    _length = _file.length();
  }

  public byte read() throws IOException
  {
    return _file.readByte();
  }

  public boolean eof() throws IOException
  {
    return _length == _file.getFilePointer();
  }

  public void close() throws IOException
  {
    _file.close();
  }

  public void seek( long index ) throws IOException
  {
    _file.seek( index );
  }

  public long getCurrentIndex() throws IOException
  {
    return _file.getFilePointer();
  }


}
