package liaquay.stream;

import java.io.*;

public class OffsetSeekableByteInputStream implements SeekableByteInputStream, ByteInputStream
{
  private SeekableByteInputStream _in;
  private long _offset;

  public OffsetSeekableByteInputStream( SeekableByteInputStream in, long offset ) throws IOException
  {
    _in = in;
    _offset = offset;

    _in.seek( _offset );
  }

  public byte read() throws IOException
  {
    return _in.read();
  }

  public boolean eof() throws IOException
  {
    return _in.eof();
  }

  public void close() throws IOException
  {
    _in.close();
  }

  public void seek( long index ) throws IOException
  {
    _in.seek( index + _offset );
  }

  public long getCurrentIndex() throws IOException
  {
    return _in.getCurrentIndex();
  }

}