package liaquay.stream;

import java.io.*;

public class StreamBitInputStream implements BitInputStream
{
  private InputStream _in;
  private long _index = 0;
  private byte _currentByte;
  private long _length;

  public StreamBitInputStream( InputStream in,
                               long length ) throws IOException
  {
    _in = in;
    if( length > 0 )
    {
      _currentByte = (byte)_in.read();
    }
    _length = length;
  }

  public boolean read() throws IOException
  {
    boolean bit = ( _currentByte & ( 1 << ( 7 - ( _index & 7 ) ) ) ) != 0;

    ++_index;

    if( !eof() && (( _index & 7 ) == 0) )
    {
      _currentByte = (byte)_in.read();
    }

    return bit;
  }

  public boolean eof() throws IOException
  {
    return _index >= _length;
  }

  public void close() throws IOException
  {
    _in.close();
  }

  public long getCurrentIndex() throws IOException
  {
    return _index;
  }
}
