package liaquay.stream;

import java.io.*;

public class XorBitOutputStream implements BitOutputStream
{
  private BitOutputStream _out;
  private BitInputStream _in;;

  public XorBitOutputStream( BitOutputStream out, BitInputStream in )
  {
    _out = out;
    _in = in;
  }

  public void write( boolean bit ) throws IOException
  {
    _out.write( bit != _in.read() );
  }

  public void write( boolean[] bits ) throws IOException
  {
    for( int i = 0; i < bits.length; ++i )
    {
      write( bits[ i ] );
    }
  }

  public void close() throws IOException
  {
    _in.close();
    _out.close();
  }
}
