package liaquay.stream;

import java.io.*;

public class XorSeekableBitInputStream
{
  private SeekableBitInputStream _stream1;
  private SeekableBitInputStream _stream2;
  
  public XorSeekableBitInputStream( SeekableBitInputStream stream1, SeekableBitInputStream stream2 )
  {
    _stream1 = stream1;
    _stream2 = stream2;
  }
  
  public void seek( long index ) throws IOException
  {
    _stream1.seek( index );
    _stream2.seek( index );
  }
  
  public long getCurrentIndex() throws IOException
  {
    return _stream1.getCurrentIndex();
  }
  
  public boolean read() throws IOException
  {
    return _stream1.read() != _stream2.read();
  }
  
  public boolean eof() throws IOException
  {
    return _stream1.eof() || _stream2.eof();
  }
  
  
  public void close() throws IOException
  {
    _stream1.close();
    _stream2.close();
  }
}
