package liaquay.stream.test;

import java.io.*;
import junit.framework.*;
import liaquay.stream.*;

/**
 * Bit Stream tests.
 *
 */
public class BitStreamTest extends TestCase
{
  public BitStreamTest(String name)
  {
    super(name);
  }

  public static Test suite()
  {
    return new TestSuite(BitStreamTest.class);
  }

  public void testBitStreams()
  {
    try
    {
      boolean bits[] = new boolean[ 100 ];
      for( int i = 0; i < bits.length; ++i )
      {
        bits[ i ] = Math.random() < 0.5;
      }

      ByteArrayOutputStream byteArrayOutputStream = new ByteArrayOutputStream();

      StreamBitOutputStream bitOutputStream = new StreamBitOutputStream( byteArrayOutputStream );

      bitOutputStream.write( bits );

      bitOutputStream.close();

      if( bitOutputStream.length() != bits.length )
      {
        fail( "Wrong length " + bitOutputStream.length() );
      }

      ByteArrayInputStream byteArrayInputStream = new ByteArrayInputStream( byteArrayOutputStream.toByteArray() );

      StreamBitInputStream bitInputStream = new StreamBitInputStream( byteArrayInputStream, bits.length );

      for( int i = 0; i < bits.length; ++i )
      {
        if( bits[ i ] != bitInputStream.read() )
        {
          fail( "Bits do not match at position " + i );
        }
      }
    }
    catch( IOException e )
    {
      fail( "" + e );
    }
  }
}
