package liaquay.stream.test;

import java.io.*;
import junit.framework.*;
import liaquay.stream.*;

/**
 * XorBitStream tests.
 *
 */
public class XorBitStreamTest extends TestCase
{
  public XorBitStreamTest(String name)
  {
    super(name);
  }

  public static Test suite()
  {
    return new TestSuite(XorBitStreamTest.class);
  }

  public void testBitStreams()
  {
    try
    {
      boolean bits1[] = new boolean[ 100 ];
      for( int i = 0; i < bits1.length; ++i )
      {
        bits1[ i ] = Math.random() < 0.5;
      }

      boolean bits2[] = new boolean[ 100 ];
      for( int i = 0; i < bits2.length; ++i )
      {
        bits2[ i ] = Math.random() < 0.5;
      }

      BooleanArrayBitOutputStream outputStream = new BooleanArrayBitOutputStream();
      
      XorBitOutputStream xorBitOutputStream = new XorBitOutputStream( 
          outputStream, 
          new BooleanArrayBitInputStream( bits2 ) );
     
      xorBitOutputStream.write( bits1 );
      xorBitOutputStream.close();
      
      XorSeekableBitInputStream bitInputStream = new XorSeekableBitInputStream(
          new BooleanArrayBitInputStream( outputStream.getBits() ),
          new BooleanArrayBitInputStream( bits2 ) );

      for( int i = 0; i < bits1.length; ++i )
      {
        if( bits1[ i ] != bitInputStream.read() )
        {
          fail( "Bits do not match at position " + i );
        }
      }
    }
    catch( IOException e )
    {
      fail( "" + e );
    }
  }
}
