package liaquay.text;

import liaquay.collection.*;

class Frequency
{
  long _freq;

  public Frequency()
  {
    _freq=0;
  }

  public long getFrequency()
  {
    return _freq;
  }

  public void increment()
  {
    _freq++;
  }
}

public class CharacterFrequencyMap
{

  private Hashtable _chars = new Hashtable();

  public void addCharacters( String newChars )
  {
    for (int i =0; i<newChars.length(); i++)
    {
      Character c = new Character(newChars.charAt(i));
      Object o = _chars.get(c);
      if (o==null)
      {
        // we have a new entry, add it to our hash
        Frequency f = new Frequency();
        f.increment();
        _chars.put(c, f);
      }
      else
      {
        // our entry already exists, just increment it
        Frequency f = (Frequency)o;
        f.increment();
      }
    }
  }

  public Iterator characterIterator()
  {
    return _chars.keyIterator();
  }

  public long getFrequency(char key)
  {
    Character c = new Character(key);
    Frequency f = (Frequency)_chars.get(c);
    return f.getFrequency();
  }

  public HuffTree getHuffTree()
  {
    Object[] values = new Object[ _chars.size() ];
    double[] weights = new double[ _chars.size() ];

    int index = 0;
    for( Iterator i = characterIterator(); i.hasNext(); )
    {
      Character character = (Character)i.next();
      values[ index ] = character;
      long frequency = getFrequency( character.charValue() );
      weights[ index ] = (double)frequency;
      index++;
    }

    return new HuffTree( values, weights );
  }
}
