package liaquay.text.parser;

public class Match
{
  public static final MatchUpalpha matchUpalpha = new MatchUpalpha();
  public static final MatchLoalpha matchLoalpha = new MatchLoalpha();
  public static final MatchAlpha matchAlpha = new MatchAlpha();
  public static final MatchDigit matchDigit = new MatchDigit();
  public static final MatchAlphaNumeric matchAlphaNumeric = new MatchAlphaNumeric();
  public static final MatchCtl matchCtl = new MatchCtl();
  public static final MatchHexDigit matchHexDigit = new MatchHexDigit();
}

class MatchUpalpha extends MatchCharRegion
{
  public MatchUpalpha()
  {
    add( 'A', 'Z' );
  }
}

class MatchLoalpha extends MatchCharRegion
{
  public MatchLoalpha()
  {
    add( 'a', 'z' );
  }
}

class MatchAlpha extends MatchCharRegion
{
  public MatchAlpha()
  {
    add( Match.matchUpalpha );
    add( Match.matchLoalpha );
  }
}
class MatchAlphaNumeric extends MatchCharRegion
{
  public MatchAlphaNumeric()
  {
    add( Match.matchAlpha );
    add( Match.matchDigit );
  }
}

class MatchDigit extends MatchCharRegion
{
  public MatchDigit()
  {
    add( '0', '9' );
  }
}

class MatchCtl extends MatchCharRegion
{
  public MatchCtl()
  {
    add( (char)0, (char)31 );
    add( (char)127 );
  }
}

class MatchHexDigit extends MatchCharRegion
{
  public MatchHexDigit()
  {
    add( 'A', 'F' );
    add( 'a', 'f' );
    add( Match.matchDigit );
  }
}


