package liaquay.text.parser;

public class ParseFixedPoint extends ParseSequence
{
  private ParseSignedInteger _integer = new ParseSignedInteger();
  private ParseAnyWidthInteger _fraction = new ParseAnyWidthInteger();

  public ParseFixedPoint()
  {
    add( _integer );
    ParseOptions options = new ParseOptions();
    ParseSequence pointAndFraction = new ParseSequence();
    pointAndFraction.add( new ParseCharLiteral( (char)'.' ) );
    pointAndFraction.add( _fraction );
    options.add( pointAndFraction );
    add( options );
  }

  public double value()
  {
    try
    {
      return Double.valueOf( new String( getMatchedChars() ) ).doubleValue(); // NB ASCII ENCODING
    }
    catch( NumberFormatException e )
    {
      throw new Error( "Could not parse fixed point number" );
    }
  }

}