package liaquay.text.parser;

public class ParseFloatingPoint extends ParseSequence
{
  private ParseFixedPoint _fixedPoint = new ParseFixedPoint();
  private ParseSignedInteger _exponent = new ParseSignedInteger();

  public ParseFloatingPoint()
  {
    add( _fixedPoint );
    ParseOptions options = new ParseOptions();
    ParseSequence exponent = new ParseSequence();
    exponent.add( new ParseCharLiteral( (char)'e' ) );
    exponent.add( _exponent );
    options.add( exponent );
    add( options );
  }

  public double value()
  {
    try
    {
      return Double.valueOf( new String( getMatchedChars() ) ).doubleValue(); // NB ASCII ENCODING
    }
    catch( NumberFormatException e )
    {
      throw new Error( "Could not parse floating point number" );
    }
  }

}