package liaquay.text.parser;

import java.io.*;

public class ParseNChars extends CharsParser
{
  private char[] _b;
  private MatchChar _matchChar;
  private int _numberToMatch;

  public ParseNChars( MatchChar matchChar, int numberToMatch )
  {
    _matchChar = matchChar;
    _numberToMatch = numberToMatch;
  }

  protected boolean parseChars( CharReader r )
    throws IOException
  {
    for( int i = 0; i < _numberToMatch; ++i )
    {
      int c = r.read();

      if( c == -1 ) return false;

      if( !_matchChar.match( (char)c ) ) return false;
    }
    return true;
  }

  protected void matched( Region region )
  {
    _b = region.getChars();
  }

  public char[] getMatchedChars()
  {
    return _b;
  }
}
