package liaquay.text.parser;

import liaquay.collection.ArrayList;
import java.io.*;

public class ParseOneOrMore extends CompoundParser
{
  private ParserFactory _factory;
  private int _matches = 0;

  public ParseOneOrMore( ParserFactory factory )
  {
    _factory = factory;
    setKeepContents( false );
  }

  public void clear()
  {
    removeAll();
    super.clear();
  }

  protected boolean parseChars( CharReader r )
    throws IOException, ParserException
  {
    removeAll();

    _matches = 0;

    for( boolean matched = true; matched; )
    {
      CharsParser parser = _factory.create();

      matched = parser.parse( r );

      if( matched )
      {
        ++_matches;
      }

      add( parser );
   }

    return _matches > 0;
  }
}
