package liaquay.text.parser;

import java.io.*;

public class ParseOneOrMoreChars extends CharsParser
{
  private char[] _b;
  private MatchChar _matchChar;
  private int _maxNumberToMatch;

  public ParseOneOrMoreChars( MatchChar matchChar )
  {
    _matchChar = matchChar;
    _maxNumberToMatch = 0;
  }

  public ParseOneOrMoreChars( MatchChar matchChar, int maxNumberToMatch )
  {
    _matchChar = matchChar;
    _maxNumberToMatch = maxNumberToMatch;
  }

  protected boolean parseChars( CharReader r )
    throws IOException
  {
    for( int i = 0; ( _maxNumberToMatch == 0 ) || ( i < _maxNumberToMatch ); ++i )
    {
      int c = r.read();

      if( c == -1 )
      {
        return i > 0;
      }

      if( !_matchChar.match( (char)c ) )
      {
        r.rewind( 1 );
        return i > 0;
      }
    }
    return true;
  }

  protected void matched( Region region )
  {
    _b = region.getChars();
  }

  public char[] getMatchedChars()
  {
    return _b;
  }

  public String getMatchedString()
  {
    return new String( _b );
  }
}


