package liaquay.text.parser;

import liaquay.collection.ArrayList;
import java.io.*;

public class ParsePositiveIntegerSet extends ParseSequence
{
  ParseZeroOrMore _numberParsers = null;

  public ParsePositiveIntegerSet()
  {
    setKeepContents( false );
    
    _numberParsers = new ParseZeroOrMore(
        new ParserFactory() 
        {
          public CharsParser create()
          {
            ParseSequence s1 = new ParseSequence();
            s1.add( new ParseWhiteSpace() );
            s1.add( new ParseAnyWidthInteger() );
            return s1;
          }
        }
      );    
    
    add( new ParseCharLiteral( '(' ) ); 
    add( _numberParsers );
    add( new ParseWhiteSpace() );
    add( new ParseCharLiteral( ')' ) );
  }

  public int getNumberOfNumbers()
  {
    return _numberParsers.getNumberOfParsers();
  }

  public long getNumber( int i )
  {
    ParseSequence s = (ParseSequence)_numberParsers.getParser( i );
    ParseAnyWidthInteger w = (ParseAnyWidthInteger)s.getParser( 1 );
    return w.value();
  }

  public int[] getIntegerArray()
  {
    int v[] = new int[ getNumberOfNumbers() ];
    for( int i = 0; i < getNumberOfNumbers(); ++i )
    {
      v[ i ] = (int)getNumber( i );
    }
    return v;
  }
}
