package liaquay.text.parser;

import java.io.*;
import liaquay.collection.ArrayList;
import liaquay.text.IndentWriter;

public class ParseSequence extends CompoundParser
{
  protected boolean parseChars( CharReader r )
    throws IOException, ParserException
  {
    for( int i = 0; i < getNumberOfParsers(); ++i )
    {
      CharsParser parser = getParser( i );

      if( !parser.parseSequential( r ) )
      {
        return false;
      }

    }
    return true;
  }

  public void explain( IndentWriter writer ) throws IOException
  {
    if( getMatched() )
    {
      writer.write( getName() + " matched ok\n" );
    }
    else
    {
      writer.write( getName() + " failed to match\n" );

      writer.increaseIndent();

      for( int i = 0; i < getNumberOfParsers(); ++i )
      {
        CharsParser parser = getParser( i );

        parser.explain( writer );
      }

      writer.decreaseIndent();
    }
  }
}
