package liaquay.text.parser;

import liaquay.collection.ArrayList;
import java.io.*;

public class ParseZeroOrMore extends CompoundParser
{
  private ParserFactory _factory;

  public ParseZeroOrMore( ParserFactory factory )
  {
    _factory = factory;
    setKeepContents( false );
  }

  public void clear()
  {
    removeAll();
    super.clear();
  }

  protected boolean parseChars( CharReader r )
    throws IOException, ParserException
  {
    removeAll();

    for( boolean matched = true; matched; )
    {
      CharsParser parser = _factory.create();

      matched = parser.parse( r );

      if( matched )
      {
        add( parser );
      }
    }

    return true;
  }
}
