package liaquay.text.parser.test;

import java.io.*;
import junit.framework.*;
import liaquay.text.parser.CharReader;

/**
 * CharReader tests.
 */
public class CharReaderTest extends TestCase
{
  public CharReaderTest(String name)
  {
    super(name);
  }

  protected void setUp()
  {
  }

  public static Test suite()
  {
    /*
     * the dynamic way
     */
    return new TestSuite(CharReaderTest.class);
  }

  public static void main (String[] args)
  {
    junit.textui.TestRunner.run (suite());
  }

  public void test1()
  {
    try
    {
      CharArrayReader inputStream = new CharArrayReader(
        new String( "012345" ).toCharArray() );

      CharReader reader = new CharReader( inputStream );

      reader.mark();
      assertEquals( '0', reader.read() );
      assertEquals( '1', reader.read() );
      assertEquals( '2', reader.read() );
      reader.rollback();
      reader.mark();
      assertEquals( '0', reader.read() );
      assertEquals( '1', reader.read() );
      assertEquals( '2', reader.read() );
      assertEquals( '3', reader.read() );
      assertEquals( '4', reader.read() );
      assertEquals( '5', reader.read() );
      assertEquals( -1, reader.read() );

    }
    catch( Exception e )
    {
      fail( "" + e );
    }
  }

  public void test2()
  {
    try
    {
      CharArrayReader inputStream = new CharArrayReader(
        new String( "0" ).toCharArray() );

      CharReader reader = new CharReader( inputStream );

      reader.mark();
      assertEquals( '0', reader.read() );
      assertEquals( -1, reader.read() );
      reader.rollback();
      reader.mark();
      assertEquals( '0', reader.read() );
      assertEquals( -1, reader.read() );


    }
    catch( Exception e )
    {
      fail( "" + e );
    }
  }
}
