package liaquay.text.parser.test;

import java.io.*;
import junit.framework.*;
import liaquay.text.parser.*;


/**
 * MatchCharRegion tests.
 */
public class MatchCharRegionTest extends TestCase
{
  public MatchCharRegionTest(String name)
  {
    super(name);
  }

  protected void setUp()
  {
  }

  public static Test suite()
  {
    /*
     * the dynamic way
     */
    return new TestSuite(MatchCharRegionTest.class);
  }

  public static void main (String[] args)
  {
    junit.textui.TestRunner.run (suite());
  }

  public void test1()
  {
    MatchCharRegion r = new MatchCharRegion();
    assertEquals( 0, r.allMatches().length );
  }

  public void test2()
  {
    MatchCharRegion r = new MatchCharRegion();
    r.add( 'A' );
    assertEquals( 1, r.allMatches().length );

    assertEquals( true, r.match( 'A' ) );
    assertEquals( false, r.match( 'a' ) );
  }

  public void test3()
  {
    MatchCharRegion r = new MatchCharRegion();
    r.add( 'A', 'C' );
    assertEquals( 3, r.allMatches().length );

    assertEquals( true, r.match( 'A' ) );
    assertEquals( true, r.match( 'B' ) );
    assertEquals( true, r.match( 'C' ) );
    assertEquals( false, r.match( 'a' ) );
  }

  public void test4()
  {
    MatchCharRegion r = new MatchCharRegion();
    r.add( 'A', 'C' );
    r.remove( 'B' );
    assertEquals( 2, r.allMatches().length );

    assertEquals( true, r.match( 'A' ) );
    assertEquals( false, r.match( 'B' ) );
    assertEquals( true, r.match( 'C' ) );
    assertEquals( false, r.match( 'a' ) );
  }


  public void test5()
  {
    MatchCharRegion r = new MatchCharRegion();
    r.add( 'A', 'C' );
    r.remove( 'B', 'C' );
    assertEquals( 1, r.allMatches().length );

    assertEquals( true, r.match( 'A' ) );
    assertEquals( false, r.match( 'B' ) );
    assertEquals( false, r.match( 'C' ) );
    assertEquals( false, r.match( 'a' ) );
  }


  public void test6()
  {
    MatchCharRegion r1 = new MatchCharRegion();
    r1.add( 'A', 'B' );
    MatchCharRegion r2 = new MatchCharRegion();
    r2.add( 'C', 'D' );
    r1.add( r2 );

    assertEquals( 4, r1.allMatches().length );

    assertEquals( true, r1.match( 'A' ) );
    assertEquals( true, r1.match( 'B' ) );
    assertEquals( true, r1.match( 'C' ) );
    assertEquals( true, r1.match( 'D' ) );
  }

  public void test7()
  {
    MatchCharRegion r1 = new MatchCharRegion();
    r1.add( 'A', 'D' );
    MatchCharRegion r2 = new MatchCharRegion();
    r2.add( 'C', 'D' );
    r1.remove( r2 );

    assertEquals( 2, r1.allMatches().length );

    assertEquals( true, r1.match( 'A' ) );
    assertEquals( true, r1.match( 'B' ) );
  }
}