package liaquay.text.parser.test;

import java.io.*;
import junit.framework.*;
import liaquay.text.parser.*;

/**
 * ParsePositiveIntegerSet tests.
 */
public class ParsePositiveIntegerSetTest extends TestCase 
{
  public ParsePositiveIntegerSetTest(String name) 
  {
    super(name);
  }
  
  protected void setUp() 
  {
  }
  
  public static Test suite() 
  {
    /*
     * the dynamic way
     */
    return new TestSuite(ParsePositiveIntegerSetTest.class);
  }
  
  
  public void test1()
  {
    ParsePositiveIntegerSet parser = new ParsePositiveIntegerSet();

    try
    {
      parser.parseSequential( "(1 2 3 4)" );

      if( parser.getMatched() )
      {
        assertEquals( 4, parser.getNumberOfNumbers() );
        assertEquals( 1, parser.getNumber( 0 ) );
        assertEquals( 2, parser.getNumber( 1 ) );
        assertEquals( 3, parser.getNumber( 2 ) );
        assertEquals( 4, parser.getNumber( 3 ) );
      }
      else
      {
        fail( "Could not parse input string (1)\n" + parser.explain() );
      }      
    }
    catch( Exception e )
    {
      fail( "Could not parse input string (2)\n" + parser.explain() + "\n" + e );
    }  
    
    try
    {
      parser.parseSequential( "(5 6 7 8)" );

      if( parser.getMatched() )
      {
        assertEquals( 4, parser.getNumberOfNumbers() );
        assertEquals( 5, parser.getNumber( 0 ) );
        assertEquals( 6, parser.getNumber( 1 ) );
        assertEquals( 7, parser.getNumber( 2 ) );
        assertEquals( 8, parser.getNumber( 3 ) );
      }
      else
      {
        fail( "Could not parse input string (1)\n" + parser.explain() );
      }      
    }
    catch( Exception e )
    {
      fail( "Could not parse input string (2)\n" + parser.explain() + "\n" + e );
    }     
  }
}
