package liaquay.text.parser.test;

import java.io.*;
import junit.framework.*;
import liaquay.text.parser.CharReader;
import liaquay.text.parser.ParseSignedInteger;


/**
 * CharReader tests.
 */
public class ParseSignedIntegerTest extends TestCase 
{
  public ParseSignedIntegerTest(String name) 
  {
    super(name);
  }
  
  protected void setUp() 
  {
  }
  
  public static Test suite() 
  {
    /*
     * the dynamic way
     */
    return new TestSuite(ParseSignedIntegerTest.class);
  }
  
  
  public void test1()
  {
    ParseSignedInteger parser = new ParseSignedInteger();

    try
    {
      parser.parseSequential( "-1234" );

      if( parser.getMatched() )
      {
        assertEquals( -1234, parser.value() );
      }
      else
      {
        fail( "Could not parse input string\n" + parser.explain() );
      }      
    }
    catch( Exception e )
    {
      fail( "Could not parse input string\n" + parser.explain() );
    }  
  }
  
  public void test2()
  {
    ParseSignedInteger parser = new ParseSignedInteger();

    try
    {
      parser.parseSequential( "1234" );

      if( parser.getMatched() )
      {
        assertEquals( 1234, parser.value() );
      }
      else
      {
        fail( "Could not parse input string\n" + parser.explain() );
      }      
    }
    catch( Exception e )
    {
      fail( "Could not parse input string\n" + parser.explain() );
    }  
  }


  public void test3()
  {
    ParseSignedInteger parser = new ParseSignedInteger();

    try
    {
      parser.parseSequential( "+1234" );

      if( parser.getMatched() )
      {
        assertEquals( 1234, parser.value() );
      }
      else
      {
        fail( "Could not parse input string\n" + parser.explain() );
      }      
    }
    catch( Exception e )
    {
      fail( "Could not parse input string\n" + parser.explain() );
    }  
  }
}
